/* A Bison parser, made by GNU Bison 2.4.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
   2009, 2010 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;
    if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
};



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY);
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;



/* Line 189 of yacc.c  */
#line 535 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIGURE = 302,
     DOWN = 303,
     KERNEL = 304,
     PERSIST = 305,
     SCAN = 306,
     TIME = 307,
     LEARN = 308,
     DEVICE = 309,
     ROUTES = 310,
     ASYNC = 311,
     TABLE = 312,
     KRT_PREFSRC = 313,
     KRT_REALM = 314,
     ROUTER = 315,
     ID = 316,
     PROTOCOL = 317,
     PREFERENCE = 318,
     DISABLED = 319,
     DIRECT = 320,
     INTERFACE = 321,
     IMPORT = 322,
     EXPORT = 323,
     FILTER = 324,
     NONE = 325,
     STATES = 326,
     FILTERS = 327,
     PASSWORD = 328,
     FROM = 329,
     PASSIVE = 330,
     TO = 331,
     EVENTS = 332,
     PACKETS = 333,
     PROTOCOLS = 334,
     INTERFACES = 335,
     PRIMARY = 336,
     STATS = 337,
     COUNT = 338,
     FOR = 339,
     COMMANDS = 340,
     PREEXPORT = 341,
     GENERATE = 342,
     LISTEN = 343,
     BGP = 344,
     V6ONLY = 345,
     DUAL = 346,
     ADDRESS = 347,
     PORT = 348,
     PASSWORDS = 349,
     DESCRIPTION = 350,
     RELOAD = 351,
     IN = 352,
     OUT = 353,
     MRTDUMP = 354,
     MESSAGES = 355,
     RESTRICT = 356,
     MEMORY = 357,
     IGP_METRIC = 358,
     SHOW = 359,
     STATUS = 360,
     SUMMARY = 361,
     ROUTE = 362,
     SYMBOLS = 363,
     DUMP = 364,
     RESOURCES = 365,
     SOCKETS = 366,
     NEIGHBORS = 367,
     ATTRIBUTES = 368,
     ECHO = 369,
     DISABLE = 370,
     ENABLE = 371,
     RESTART = 372,
     FUNCTION = 373,
     PRINT = 374,
     PRINTN = 375,
     UNSET = 376,
     RETURN = 377,
     ACCEPT = 378,
     REJECT = 379,
     QUITBIRD = 380,
     INT = 381,
     BOOL = 382,
     IP = 383,
     PREFIX = 384,
     PAIR = 385,
     QUAD = 386,
     EC = 387,
     SET = 388,
     STRING = 389,
     BGPMASK = 390,
     BGPPATH = 391,
     CLIST = 392,
     ECLIST = 393,
     IF = 394,
     THEN = 395,
     ELSE = 396,
     CASE = 397,
     TRUE = 398,
     FALSE = 399,
     RT = 400,
     RO = 401,
     UNKNOWN = 402,
     GENERIC = 403,
     GW = 404,
     NET = 405,
     MASK = 406,
     PROTO = 407,
     SOURCE = 408,
     SCOPE = 409,
     CAST = 410,
     DEST = 411,
     LEN = 412,
     DEFINED = 413,
     ADD = 414,
     DELETE = 415,
     CONTAINS = 416,
     RESET = 417,
     PREPEND = 418,
     FIRST = 419,
     LAST = 420,
     MATCH = 421,
     EMPTY = 422,
     WHERE = 423,
     EVAL = 424,
     LOCAL = 425,
     NEIGHBOR = 426,
     AS = 427,
     HOLD = 428,
     CONNECT = 429,
     RETRY = 430,
     KEEPALIVE = 431,
     MULTIHOP = 432,
     STARTUP = 433,
     VIA = 434,
     NEXT = 435,
     HOP = 436,
     SELF = 437,
     DEFAULT = 438,
     PATH = 439,
     METRIC = 440,
     START = 441,
     DELAY = 442,
     FORGET = 443,
     WAIT = 444,
     AFTER = 445,
     BGP_PATH = 446,
     BGP_LOCAL_PREF = 447,
     BGP_MED = 448,
     BGP_ORIGIN = 449,
     BGP_NEXT_HOP = 450,
     BGP_ATOMIC_AGGR = 451,
     BGP_AGGREGATOR = 452,
     BGP_COMMUNITY = 453,
     BGP_EXT_COMMUNITY = 454,
     RR = 455,
     RS = 456,
     CLIENT = 457,
     CLUSTER = 458,
     AS4 = 459,
     ADVERTISE = 460,
     IPV4 = 461,
     CAPABILITIES = 462,
     LIMIT = 463,
     PREFER = 464,
     OLDER = 465,
     MISSING = 466,
     LLADDR = 467,
     DROP = 468,
     IGNORE = 469,
     REFRESH = 470,
     INTERPRET = 471,
     COMMUNITIES = 472,
     BGP_ORIGINATOR_ID = 473,
     BGP_CLUSTER_LIST = 474,
     IGP = 475,
     GATEWAY = 476,
     RECURSIVE = 477,
     MED = 478,
     TTL = 479,
     SECURITY = 480,
     OSPF = 481,
     AREA = 482,
     OSPF_METRIC1 = 483,
     OSPF_METRIC2 = 484,
     OSPF_TAG = 485,
     OSPF_ROUTER_ID = 486,
     RFC1583COMPAT = 487,
     STUB = 488,
     TICK = 489,
     COST = 490,
     COST2 = 491,
     RETRANSMIT = 492,
     HELLO = 493,
     TRANSMIT = 494,
     PRIORITY = 495,
     DEAD = 496,
     TYPE = 497,
     BROADCAST = 498,
     BCAST = 499,
     NONBROADCAST = 500,
     NBMA = 501,
     POINTOPOINT = 502,
     PTP = 503,
     POINTOMULTIPOINT = 504,
     PTMP = 505,
     SIMPLE = 506,
     AUTHENTICATION = 507,
     STRICT = 508,
     CRYPTOGRAPHIC = 509,
     ELIGIBLE = 510,
     POLL = 511,
     NETWORKS = 512,
     HIDDEN = 513,
     VIRTUAL = 514,
     CHECK = 515,
     LINK = 516,
     RX = 517,
     BUFFER = 518,
     LARGE = 519,
     NORMAL = 520,
     STUBNET = 521,
     TAG = 522,
     EXTERNAL = 523,
     LSADB = 524,
     ECMP = 525,
     WEIGHT = 526,
     NSSA = 527,
     TRANSLATOR = 528,
     STABILITY = 529,
     TOPOLOGY = 530,
     STATE = 531,
     PIPE = 532,
     PEER = 533,
     MODE = 534,
     OPAQUE = 535,
     TRANSPARENT = 536,
     RIP = 537,
     INFINITY = 538,
     PERIOD = 539,
     GARBAGE = 540,
     TIMEOUT = 541,
     MULTICAST = 542,
     QUIET = 543,
     NOLISTEN = 544,
     VERSION1 = 545,
     PLAINTEXT = 546,
     MD5 = 547,
     HONOR = 548,
     NEVER = 549,
     ALWAYS = 550,
     RIP_METRIC = 551,
     RIP_TAG = 552,
     STATIC = 553,
     PROHIBIT = 554,
     MULTIPATH = 555
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 457 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;



/* Line 214 of yacc.c  */
#line 895 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 907 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  54
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2322

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  322
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  211
/* YYNRULES -- Number of rules.  */
#define YYNRULES  678
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1275

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   555

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     312,   313,    28,    26,   318,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   315,   314,
      23,    22,    24,   319,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   320,     2,   321,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   316,     2,   317,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    74,
      75,    77,    80,    82,    84,    88,    90,    94,    96,    98,
     100,   102,   104,   106,   108,   110,   112,   117,   121,   123,
     125,   127,   129,   132,   137,   141,   145,   149,   153,   158,
     161,   162,   164,   167,   170,   174,   177,   181,   184,   188,
     192,   196,   201,   203,   205,   207,   212,   213,   216,   219,
     222,   224,   226,   229,   231,   232,   234,   235,   238,   241,
     244,   247,   250,   253,   256,   260,   263,   266,   268,   270,
     272,   274,   278,   282,   283,   285,   287,   290,   291,   293,
     297,   299,   303,   306,   310,   314,   318,   319,   323,   325,
     327,   331,   333,   337,   339,   341,   343,   345,   347,   349,
     351,   353,   357,   359,   363,   365,   367,   372,   374,   375,
     379,   384,   386,   389,   390,   396,   402,   408,   414,   419,
     423,   427,   432,   438,   440,   441,   445,   450,   455,   456,
     459,   463,   467,   471,   474,   477,   480,   484,   488,   491,
     494,   496,   498,   503,   507,   511,   515,   519,   523,   527,
     531,   536,   538,   540,   542,   543,   545,   549,   553,   557,
     561,   566,   571,   576,   581,   584,   586,   588,   590,   592,
     593,   595,   596,   601,   604,   606,   608,   610,   612,   614,
     616,   618,   620,   622,   624,   626,   628,   631,   634,   635,
     639,   641,   645,   647,   649,   651,   654,   658,   661,   666,
     667,   673,   674,   676,   678,   681,   683,   687,   689,   691,
     693,   695,   697,   699,   703,   705,   707,   709,   711,   713,
     717,   719,   725,   737,   739,   741,   743,   746,   748,   756,
     766,   774,   776,   778,   780,   784,   786,   788,   790,   794,
     796,   800,   802,   806,   810,   812,   815,   818,   825,   827,
     831,   832,   837,   841,   843,   847,   851,   855,   858,   861,
     864,   867,   868,   871,   874,   875,   877,   879,   881,   883,
     885,   887,   889,   893,   897,   899,   901,   907,   915,   916,
     921,   923,   925,   927,   929,   931,   933,   935,   937,   939,
     943,   947,   951,   955,   959,   963,   967,   971,   975,   979,
     983,   987,   991,   995,   998,  1003,  1005,  1007,  1009,  1011,
    1014,  1017,  1021,  1025,  1032,  1036,  1040,  1044,  1048,  1054,
    1061,  1068,  1075,  1082,  1087,  1089,  1091,  1093,  1095,  1097,
    1099,  1101,  1102,  1104,  1108,  1110,  1114,  1115,  1117,  1122,
    1129,  1134,  1138,  1144,  1150,  1155,  1162,  1166,  1169,  1175,
    1181,  1190,  1199,  1208,  1217,  1220,  1224,  1228,  1234,  1241,
    1248,  1255,  1260,  1265,  1271,  1278,  1285,  1291,  1295,  1300,
    1306,  1312,  1318,  1324,  1329,  1334,  1340,  1346,  1352,  1358,
    1364,  1370,  1376,  1383,  1390,  1399,  1406,  1413,  1419,  1424,
    1430,  1435,  1441,  1446,  1452,  1458,  1464,  1467,  1471,  1475,
    1477,  1480,  1483,  1488,  1491,  1493,  1496,  1501,  1502,  1506,
    1509,  1511,  1514,  1518,  1522,  1526,  1530,  1533,  1537,  1538,
    1544,  1545,  1551,  1554,  1557,  1559,  1564,  1566,  1568,  1569,
    1573,  1576,  1579,  1582,  1587,  1589,  1590,  1594,  1595,  1598,
    1601,  1605,  1608,  1611,  1615,  1618,  1621,  1624,  1626,  1630,
    1633,  1636,  1639,  1642,  1645,  1648,  1652,  1655,  1658,  1661,
    1664,  1667,  1670,  1673,  1676,  1680,  1683,  1687,  1690,  1694,
    1698,  1703,  1706,  1709,  1712,  1716,  1720,  1724,  1726,  1727,
    1730,  1734,  1736,  1737,  1739,  1742,  1743,  1746,  1748,  1750,
    1753,  1757,  1758,  1759,  1763,  1764,  1768,  1772,  1774,  1775,
    1780,  1787,  1794,  1801,  1809,  1816,  1824,  1831,  1834,  1838,
    1842,  1848,  1853,  1858,  1861,  1865,  1869,  1874,  1879,  1884,
    1890,  1896,  1901,  1905,  1910,  1915,  1920,  1925,  1927,  1929,
    1931,  1933,  1935,  1937,  1939,  1941,  1942,  1945,  1948,  1949,
    1953,  1954,  1958,  1959,  1963,  1966,  1970,  1974,  1980,  1986,
    1990,  1993,  1996,  2000,  2002,  2005,  2009,  2013,  2017,  2021,
    2024,  2027,  2030,  2035,  2037,  2039,  2041,  2043,  2045,  2047,
    2049,  2051,  2053,  2055,  2057,  2059,  2061,  2063,  2065,  2067,
    2069,  2071,  2073,  2075,  2077,  2079,  2081,  2083,  2085,  2087,
    2089,  2091,  2093,  2095,  2097,  2099,  2101,  2103,  2105,  2107,
    2109,  2111,  2113,  2115,  2117,  2119,  2121,  2123,  2125,  2127,
    2129,  2131,  2133,  2135,  2138,  2141,  2144,  2147,  2150,  2153,
    2156,  2159,  2163,  2167,  2171,  2175,  2179,  2183,  2187,  2189,
    2191,  2193,  2195,  2197,  2199,  2201,  2203,  2205,  2207,  2209,
    2211,  2213,  2215,  2217,  2219,  2221,  2223,  2225,  2227
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     323,     0,    -1,   324,     3,    -1,     4,   528,    -1,    -1,
     324,   527,    -1,    15,    -1,   312,   461,   313,    -1,    19,
      -1,    33,    19,    22,   325,   314,    -1,    33,    19,    22,
      18,   314,    -1,   325,    -1,    34,    -1,    36,    -1,    35,
      -1,    37,    -1,    -1,    18,    -1,    19,    -1,   328,   331,
      -1,   329,    -1,   328,    -1,    29,   325,    -1,   315,   328,
      -1,    20,    -1,    20,    -1,    -1,    38,   336,   337,   314,
      -1,    57,    20,    -1,    -1,    20,    -1,    39,   335,    -1,
      50,    -1,    40,    -1,   316,   338,   317,    -1,   339,    -1,
     338,   318,   339,    -1,    41,    -1,    42,    -1,    43,    -1,
      44,    -1,    45,    -1,    46,    -1,    47,    -1,    48,    -1,
      49,    -1,   110,    90,   377,   314,    -1,   110,    20,   314,
      -1,   118,    -1,    73,    -1,    56,    -1,    38,    -1,   341,
      20,    -1,   341,    20,   325,    20,    -1,   341,    53,    54,
      -1,   341,    53,    55,    -1,    52,   342,   314,    -1,    58,
     347,     3,    -1,    58,    51,   347,     3,    -1,    59,     3,
      -1,    -1,    20,    -1,   359,    60,    -1,    61,   327,    -1,
      62,    63,   325,    -1,    64,   327,    -1,    65,    66,   327,
      -1,   359,    65,    -1,    62,    63,   325,    -1,    92,   333,
     330,    -1,    60,    68,   325,    -1,    71,    72,   354,   314,
      -1,    15,    -1,    17,    -1,    18,    -1,    99,   100,   356,
     314,    -1,    -1,   356,   357,    -1,   103,   328,    -1,   104,
     325,    -1,   101,    -1,   102,    -1,    68,    19,    -1,    73,
      -1,    -1,    19,    -1,    -1,    74,   325,    -1,    75,   327,
      -1,    41,   374,    -1,   110,   377,    -1,    78,   362,    -1,
      79,   362,    -1,    68,   363,    -1,    71,    72,   354,    -1,
     106,    20,    -1,    80,   425,    -1,   426,    -1,    40,    -1,
      81,    -1,    19,    -1,    41,    90,   374,    -1,    41,    96,
     325,    -1,    -1,    20,    -1,   330,    -1,    20,   330,    -1,
      -1,    27,    -1,   365,   367,   366,    -1,   368,    -1,   369,
     318,   368,    -1,   359,    76,    -1,   370,   360,   316,    -1,
     371,   361,   314,    -1,   371,   373,   314,    -1,    -1,    77,
     372,   369,    -1,    40,    -1,    35,    -1,   316,   375,   317,
      -1,   376,    -1,   375,   318,   376,    -1,    82,    -1,    66,
      -1,    83,    -1,    91,    -1,    88,    -1,    89,    -1,    40,
      -1,    35,    -1,   316,   378,   317,    -1,   379,    -1,   378,
     318,   379,    -1,    82,    -1,   111,    -1,   105,   316,   381,
     317,    -1,   382,    -1,    -1,   382,   314,   381,    -1,   383,
     316,   384,   317,    -1,   383,    -1,    84,    20,    -1,    -1,
      98,    85,   332,   314,   384,    -1,    98,    87,   332,   314,
     384,    -1,   134,    85,   332,   314,   384,    -1,   134,    87,
     332,   314,   384,    -1,    72,   325,   314,   384,    -1,   115,
     116,     3,    -1,   115,   113,     3,    -1,   115,    90,   416,
       3,    -1,   115,    90,    40,   416,     3,    -1,    19,    -1,
      -1,   115,    91,     3,    -1,   115,    91,   117,     3,    -1,
     115,   118,   393,     3,    -1,    -1,   393,   329,    -1,   393,
      95,   330,    -1,   393,    68,    19,    -1,   393,    80,   425,
      -1,   393,   426,    -1,   393,    40,    -1,   393,    92,    -1,
     393,   394,    19,    -1,   393,    73,    19,    -1,   393,    93,
      -1,   393,    94,    -1,    97,    -1,    79,    -1,   115,   119,
     389,     3,    -1,   120,   121,     3,    -1,   120,   122,     3,
      -1,   120,    91,     3,    -1,   120,   123,     3,    -1,   120,
     124,     3,    -1,   120,    66,     3,    -1,   120,    90,     3,
      -1,   125,   404,   405,     3,    -1,    40,    -1,    35,    -1,
      15,    -1,    -1,    15,    -1,   126,   415,     3,    -1,   127,
     415,     3,    -1,   128,   415,     3,    -1,   107,   415,     3,
      -1,   107,   108,   415,     3,    -1,   107,   109,   415,     3,
      -1,    41,   415,   374,     3,    -1,   110,   415,   377,     3,
      -1,   112,     3,    -1,    19,    -1,    40,    -1,    20,    -1,
      19,    -1,    -1,    20,    -1,    -1,    80,    19,   418,   424,
      -1,   180,   461,    -1,   137,    -1,   138,    -1,   139,    -1,
     140,    -1,   141,    -1,   142,    -1,   143,    -1,   145,    -1,
     146,    -1,   147,    -1,   148,    -1,   149,    -1,   420,   144,
      -1,   420,    19,    -1,    -1,   421,   314,   422,    -1,   421,
      -1,   421,   314,   423,    -1,   428,    -1,    19,    -1,   424,
      -1,   179,   461,    -1,   312,   423,   313,    -1,   312,   313,
      -1,   422,   316,   431,   317,    -1,    -1,   129,    19,   430,
     427,   428,    -1,    -1,   432,    -1,   467,    -1,   432,   467,
      -1,   467,    -1,   316,   431,   317,    -1,    18,    -1,   325,
      -1,    17,    -1,   434,    -1,    16,    -1,    15,    -1,   312,
     461,   313,    -1,    17,    -1,   434,    -1,    16,    -1,   461,
      -1,   437,    -1,   437,     7,   437,    -1,    28,    -1,   312,
     438,   318,   438,   313,    -1,   312,   438,   318,   438,   313,
       7,   312,   437,   318,   437,   313,    -1,   461,    -1,   156,
      -1,   157,    -1,   158,    15,    -1,   159,    -1,   312,   441,
     318,   440,   318,   440,   313,    -1,   312,   441,   318,   440,
     318,   440,     7,   440,   313,    -1,   312,   441,   318,   440,
     318,    28,   313,    -1,   439,    -1,   442,    -1,   435,    -1,
     435,     7,   435,    -1,   439,    -1,   442,    -1,   436,    -1,
     436,     7,   436,    -1,   443,    -1,   445,   318,   443,    -1,
     444,    -1,   446,   318,   444,    -1,    18,    29,    15,    -1,
     447,    -1,   447,    26,    -1,   447,    27,    -1,   447,   316,
      15,   318,    15,   317,    -1,   448,    -1,   449,   318,   448,
      -1,    -1,   450,   446,   315,   431,    -1,   450,     6,   431,
      -1,   459,    -1,   312,   461,   313,    -1,    13,   453,    14,
      -1,    29,   454,    29,    -1,    15,   453,    -1,    28,   453,
      -1,   319,   453,    -1,   451,   453,    -1,    -1,    15,   454,
      -1,   319,   454,    -1,    -1,    15,    -1,   154,    -1,   155,
      -1,    20,    -1,   434,    -1,   447,    -1,    17,    -1,   320,
     445,   321,    -1,   320,   449,   321,    -1,    16,    -1,   452,
      -1,   312,   461,   318,   461,   313,    -1,   312,   441,   318,
     461,   318,   461,   313,    -1,    -1,    19,   312,   466,   313,
      -1,    19,    -1,    85,    -1,   160,    -1,   161,    -1,   163,
      -1,   164,    -1,   165,    -1,   166,    -1,   167,    -1,   312,
     461,   313,    -1,   461,    26,   461,    -1,   461,    27,   461,
      -1,   461,    28,   461,    -1,   461,    29,   461,    -1,   461,
      11,   461,    -1,   461,    12,   461,    -1,   461,    22,   461,
      -1,   461,    10,   461,    -1,   461,    23,   461,    -1,   461,
       9,   461,    -1,   461,    24,   461,    -1,   461,     8,   461,
      -1,   461,    25,   461,    -1,    31,   461,    -1,   169,   312,
     461,   313,    -1,   459,    -1,   455,    -1,   456,    -1,    74,
      -1,   457,   460,    -1,   457,   532,    -1,   461,    32,   139,
      -1,   461,    32,   168,    -1,   461,    32,   162,   312,   461,
     313,    -1,   461,    32,   175,    -1,   461,    32,   176,    -1,
      26,   178,    26,    -1,    27,   178,    27,    -1,    27,    27,
     178,    27,    27,    -1,   174,   312,   461,   318,   461,   313,
      -1,   170,   312,   461,   318,   461,   313,    -1,   171,   312,
     461,   318,   461,   313,    -1,    80,   312,   461,   318,   461,
     313,    -1,    19,   312,   466,   313,    -1,   136,    -1,   134,
      -1,   135,    -1,    46,    -1,   130,    -1,   131,    -1,   461,
      -1,    -1,   463,    -1,   463,   318,   464,    -1,   461,    -1,
     461,   318,   465,    -1,    -1,   465,    -1,   150,   461,   151,
     433,    -1,   150,   461,   151,   433,   152,   433,    -1,    19,
      22,   461,   314,    -1,   133,   461,   314,    -1,   457,   532,
      22,   461,   314,    -1,   457,   460,    22,   461,   314,    -1,
      74,    22,   461,   314,    -1,   132,   312,   457,   532,   313,
     314,    -1,   462,   464,   314,    -1,   458,   314,    -1,   153,
     461,   316,   450,   317,    -1,   457,   532,    32,   178,   314,
      -1,   457,   532,    32,   174,   312,   461,   313,   314,    -1,
     457,   532,    32,   170,   312,   461,   313,   314,    -1,   457,
     532,    32,   171,   312,   461,   313,   314,    -1,   457,   532,
      32,    80,   312,   461,   313,   314,    -1,   359,   100,    -1,
     468,   360,   316,    -1,   469,   361,   314,    -1,   469,   181,
     183,   325,   314,    -1,   469,   181,   328,   183,   325,   314,
      -1,   469,   182,   328,   183,   325,   314,    -1,   469,   211,
     214,    72,   354,   314,    -1,   469,   211,   213,   314,    -1,
     469,   212,   213,   314,    -1,   469,   184,    63,   325,   314,
      -1,   469,   189,   184,    63,   325,   314,    -1,   469,   185,
     186,    63,   325,   314,    -1,   469,   187,    63,   325,   314,
      -1,   469,   188,   314,    -1,   469,   188,   325,   314,    -1,
     469,   191,   192,   193,   314,    -1,   469,   222,   223,   193,
     314,    -1,   469,   222,   223,   224,   314,    -1,   469,   222,
     223,   225,   314,    -1,   469,   232,    76,   314,    -1,   469,
     232,   233,   314,    -1,   469,   195,   196,   327,   314,    -1,
     469,   234,   196,   327,   314,    -1,   469,   231,   196,   327,
     314,    -1,   469,   220,   221,   327,   314,    -1,   469,   194,
     204,   325,   314,    -1,   469,   194,   203,   325,   314,    -1,
     469,   164,   103,   328,   314,    -1,   469,   197,   198,    63,
     325,   314,    -1,   469,    46,   199,    63,   325,   314,    -1,
     469,    46,   200,    63,   325,   318,   325,   314,    -1,   469,
     126,   201,    46,   327,   314,    -1,   469,   127,   118,   226,
     327,   314,    -1,   469,   127,   215,   327,   314,    -1,   469,
     218,   327,   314,    -1,   469,   216,   217,   327,   314,    -1,
     469,    84,    20,   314,    -1,   469,   118,   219,   325,   314,
      -1,   469,    86,   327,   314,    -1,   469,   227,   228,   327,
     314,    -1,   469,   231,    68,   363,   314,    -1,   469,   235,
     236,   327,   314,    -1,   359,   237,    -1,   470,   360,   316,
      -1,   471,   472,   314,    -1,   361,    -1,   243,   327,    -1,
     281,   327,    -1,   281,   327,   219,   325,    -1,   245,   325,
      -1,   474,    -1,   238,   354,    -1,   473,   316,   475,   317,
      -1,    -1,   475,   476,   314,    -1,   244,   327,    -1,   283,
      -1,   117,   327,    -1,   194,   283,   327,    -1,   194,   246,
     325,    -1,   194,   247,   325,    -1,   244,   246,   325,    -1,
     284,   327,    -1,   284,   285,   325,    -1,    -1,   268,   477,
     316,   488,   317,    -1,    -1,   279,   478,   316,   488,   317,
      -1,   277,   479,    -1,    77,   499,    -1,   483,    -1,   480,
     316,   481,   317,    -1,   480,    -1,   329,    -1,    -1,   481,
     482,   314,    -1,   269,   327,    -1,   117,   327,    -1,   246,
     325,    -1,   486,   316,   484,   317,    -1,   486,    -1,    -1,
     484,   485,   314,    -1,    -1,   249,   325,    -1,   248,   325,
      -1,   250,   198,   325,    -1,   200,   325,    -1,   252,   325,
      -1,   252,    94,   325,    -1,   263,    81,    -1,   263,   262,
      -1,   263,   265,    -1,   380,    -1,   270,   272,   354,    -1,
     246,   325,    -1,   249,   325,    -1,   267,   325,    -1,   248,
     325,    -1,   200,   325,    -1,   252,   325,    -1,   252,    94,
     325,    -1,   253,   254,    -1,   253,   255,    -1,   253,   256,
      -1,   253,   257,    -1,   253,   258,    -1,   253,   259,    -1,
     253,   260,    -1,   253,   261,    -1,   250,   198,   325,    -1,
     251,   325,    -1,   264,   256,   327,    -1,   244,   327,    -1,
     271,   272,   327,    -1,   281,   282,   325,    -1,   123,   316,
     492,   317,    -1,   263,    81,    -1,   263,   262,    -1,   263,
     265,    -1,   273,   274,   275,    -1,   273,   274,   276,    -1,
     273,   274,   325,    -1,   380,    -1,    -1,   488,   489,    -1,
     490,   491,   314,    -1,   329,    -1,    -1,   269,    -1,   278,
     325,    -1,    -1,   492,   493,    -1,   494,    -1,   495,    -1,
      18,   314,    -1,    18,   266,   314,    -1,    -1,    -1,   497,
     487,   314,    -1,    -1,   316,   497,   317,    -1,   496,   369,
     498,    -1,    20,    -1,    -1,   115,   237,   389,     3,    -1,
     115,   237,   123,   389,   500,     3,    -1,   115,   237,    77,
     389,   500,     3,    -1,   115,   237,   286,   389,   500,     3,
      -1,   115,   237,   286,    40,   389,   500,     3,    -1,   115,
     237,   287,   389,   500,     3,    -1,   115,   237,   287,    40,
     389,   500,     3,    -1,   115,   237,   280,   389,   500,     3,
      -1,   359,   288,    -1,   509,   360,   316,    -1,   510,   361,
     314,    -1,   510,   289,    68,    19,   314,    -1,   510,   290,
     291,   314,    -1,   510,   290,   292,   314,    -1,   359,   293,
      -1,   511,   360,   316,    -1,   512,   361,   314,    -1,   512,
     294,   325,   314,    -1,   512,   104,   325,   314,    -1,   512,
     295,   325,   314,    -1,   512,   296,    63,   325,   314,    -1,
     512,   297,    63,   325,   314,    -1,   512,   263,   513,   314,
      -1,   512,   380,   314,    -1,   512,   304,   306,   314,    -1,
     512,   304,   182,   314,    -1,   512,   304,   305,   314,    -1,
     512,    77,   519,   314,    -1,   302,    -1,   303,    -1,    81,
      -1,   254,    -1,   298,    -1,   299,    -1,   300,    -1,   301,
      -1,    -1,   196,   325,    -1,   290,   514,    -1,    -1,   516,
     515,   314,    -1,    -1,   316,   516,   317,    -1,    -1,   518,
     369,   517,    -1,   359,   309,    -1,   520,   360,   316,    -1,
     521,   361,   314,    -1,   521,   271,   272,   327,   314,    -1,
     521,   231,    68,   363,   314,    -1,   521,   525,   314,    -1,
     118,   329,    -1,   190,   328,    -1,   523,   282,   325,    -1,
     523,    -1,   524,   523,    -1,   522,   190,   328,    -1,   522,
     190,    20,    -1,   522,   311,   524,    -1,   522,   233,   328,
      -1,   522,   224,    -1,   522,   135,    -1,   522,   310,    -1,
     115,   309,   389,     3,    -1,   314,    -1,   326,    -1,   334,
      -1,   340,    -1,   343,    -1,   353,    -1,   355,    -1,   358,
      -1,   529,    -1,   364,    -1,   417,    -1,   419,    -1,   429,
      -1,   344,    -1,   345,    -1,   346,    -1,   385,    -1,   386,
      -1,   387,    -1,   388,    -1,   390,    -1,   391,    -1,   392,
      -1,   395,    -1,   396,    -1,   397,    -1,   398,    -1,   399,
      -1,   400,    -1,   401,    -1,   402,    -1,   403,    -1,   406,
      -1,   407,    -1,   408,    -1,   409,    -1,   410,    -1,   411,
      -1,   412,    -1,   413,    -1,   414,    -1,   501,    -1,   502,
      -1,   503,    -1,   504,    -1,   505,    -1,   506,    -1,   507,
      -1,   508,    -1,   526,    -1,   530,   317,    -1,   531,   317,
      -1,   371,   317,    -1,   469,   317,    -1,   471,   317,    -1,
     510,   317,    -1,   512,   317,    -1,   521,   317,    -1,   348,
     360,   316,    -1,   530,   361,   314,    -1,   530,   349,   314,
      -1,   530,   352,   314,    -1,   350,   360,   316,    -1,   531,
     361,   314,    -1,   531,   351,   314,    -1,    69,    -1,    70,
      -1,   114,    -1,     5,    -1,   205,    -1,   202,    -1,   206,
      -1,   204,    -1,   203,    -1,   207,    -1,   208,    -1,   209,
      -1,   229,    -1,   230,    -1,   210,    -1,   239,    -1,   240,
      -1,   241,    -1,   242,    -1,   307,    -1,   308,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   617,   617,   618,   621,   623,   630,   631,   632,   638,
     642,   651,   652,   653,   654,   655,   656,   662,   663,   670,
     677,   678,   682,   686,   693,   701,   702,   708,   717,   718,
     722,   727,   728,   732,   733,   737,   738,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   756,   757,   766,   767,
     768,   769,   772,   773,   774,   775,   779,   786,   789,   792,
     796,   797,   805,   821,   822,   826,   833,   839,   852,   856,
     869,   882,   888,   889,   890,   901,   903,   905,   909,   910,
     911,   912,   919,   927,   931,   937,   943,   945,   949,   950,
     951,   952,   953,   954,   955,   956,   960,   961,   962,   963,
     967,   975,   976,   984,   992,   993,   994,   998,   999,  1003,
    1008,  1009,  1016,  1025,  1026,  1027,  1031,  1040,  1046,  1047,
    1048,  1052,  1053,  1057,  1058,  1059,  1060,  1061,  1062,  1068,
    1069,  1070,  1074,  1075,  1079,  1080,  1086,  1087,  1090,  1092,
    1096,  1097,  1101,  1119,  1120,  1121,  1122,  1123,  1124,  1132,
    1135,  1138,  1141,  1145,  1146,  1149,  1152,  1155,  1159,  1165,
    1171,  1178,  1183,  1188,  1193,  1197,  1201,  1211,  1219,  1223,
    1230,  1231,  1234,  1238,  1240,  1242,  1244,  1246,  1248,  1250,
    1253,  1259,  1260,  1261,  1265,  1266,  1272,  1274,  1276,  1278,
    1280,  1282,  1286,  1290,  1293,  1297,  1298,  1299,  1303,  1304,
    1305,  1313,  1313,  1323,  1327,  1328,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,  1338,  1339,  1360,  1371,  1372,
    1379,  1380,  1387,  1396,  1400,  1404,  1428,  1429,  1433,  1446,
    1446,  1462,  1463,  1466,  1467,  1471,  1474,  1483,  1496,  1497,
    1498,  1499,  1503,  1504,  1505,  1506,  1507,  1511,  1514,  1515,
    1516,  1520,  1523,  1532,  1535,  1536,  1537,  1538,  1542,  1543,
    1544,  1548,  1549,  1550,  1551,  1555,  1556,  1557,  1558,  1562,
    1563,  1567,  1568,  1572,  1579,  1580,  1581,  1582,  1589,  1590,
    1593,  1594,  1601,  1613,  1614,  1618,  1619,  1623,  1624,  1625,
    1626,  1627,  1631,  1632,  1633,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1651,  1652,  1662,  1666,
    1689,  1725,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1754,  1755,  1756,  1758,  1760,
    1762,  1764,  1765,  1766,  1767,  1768,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1789,  1812,  1813,  1814,  1815,  1816,  1817,
    1821,  1824,  1825,  1826,  1835,  1842,  1851,  1852,  1856,  1862,
    1872,  1881,  1887,  1892,  1899,  1904,  1910,  1911,  1912,  1920,
    1921,  1922,  1923,  1924,  1930,  1952,  1953,  1954,  1955,  1956,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  2008,  2019,  2020,  2024,
    2025,  2026,  2027,  2028,  2029,  2032,  2047,  2050,  2052,  2056,
    2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2065,
    2066,  2066,  2067,  2068,  2069,  2073,  2074,  2078,  2086,  2088,
    2092,  2093,  2094,  2098,  2099,  2102,  2104,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2120,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,
    2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,  2162,
    2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2173,  2175,
    2178,  2180,  2189,  2191,  2192,  2195,  2197,  2201,  2202,  2204,
    2213,  2224,  2244,  2246,  2249,  2251,  2255,  2259,  2260,  2264,
    2267,  2270,  2275,  2278,  2283,  2286,  2289,  2295,  2303,  2304,
    2305,  2310,  2311,  2317,  2324,  2325,  2326,  2327,  2328,  2329,
    2330,  2331,  2332,  2333,  2334,  2335,  2336,  2340,  2341,  2342,
    2347,  2348,  2349,  2350,  2351,  2354,  2355,  2356,  2359,  2361,
    2364,  2366,  2370,  2379,  2386,  2393,  2394,  2395,  2396,  2397,
    2400,  2409,  2416,  2423,  2424,  2428,  2432,  2438,  2441,  2445,
    2446,  2447,  2450,  2457,  2457,  2457,  2457,  2457,  2457,  2457,
    2457,  2457,  2457,  2457,  2457,  2457,  2458,  2458,  2458,  2458,
    2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,
    2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,
    2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,  2458,
    2458,  2458,  2458,  2459,  2459,  2459,  2459,  2459,  2459,  2459,
    2459,  2460,  2460,  2460,  2460,  2461,  2461,  2461,  2462,  2462,
    2462,  2463,  2463,  2464,  2465,  2466,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2474,  2474,  2474,  2474,  2474
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ROUTES", "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM",
  "ROUTER", "ID", "PROTOCOL", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PORT", "PASSWORDS", "DESCRIPTION", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "SHOW", "STATUS",
  "SUMMARY", "ROUTE", "SYMBOLS", "DUMP", "RESOURCES", "SOCKETS",
  "NEIGHBORS", "ATTRIBUTES", "ECHO", "DISABLE", "ENABLE", "RESTART",
  "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT", "REJECT",
  "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD", "EC", "SET",
  "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST", "IF", "THEN", "ELSE",
  "CASE", "TRUE", "FALSE", "RT", "RO", "UNKNOWN", "GENERIC", "GW", "NET",
  "MASK", "PROTO", "SOURCE", "SCOPE", "CAST", "DEST", "LEN", "DEFINED",
  "ADD", "DELETE", "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST",
  "MATCH", "EMPTY", "WHERE", "EVAL", "LOCAL", "NEIGHBOR", "AS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP", "STARTUP", "VIA", "NEXT",
  "HOP", "SELF", "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET",
  "WAIT", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN",
  "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "LIMIT", "PREFER", "OLDER", "MISSING", "LLADDR",
  "DROP", "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES",
  "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE",
  "MED", "TTL", "SECURITY", "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2",
  "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST",
  "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "CHECK", "LINK", "RX", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT",
  "RIP", "INFINITY", "PERIOD", "GARBAGE", "TIMEOUT", "MULTICAST", "QUIET",
  "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS",
  "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "'('", "')'",
  "';'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "expr", "definition", "bool", "ipa", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "newtab", "proto_start", "proto_name", "proto_item", "imexport",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "pair_expr", "pair_atom", "pair_item", "ec_expr",
  "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "ipa_list", "ipa_item", "ipa_el", "ipa_ne",
  "ospf_iface_start", "ospf_iface_opts", "ospf_iface_opt_list",
  "ospf_iface", "opttext", "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS",
  "cmd_SHOW_OSPF_INTERFACE", "cmd_SHOW_OSPF_TOPOLOGY",
  "cmd_SHOW_OSPF_TOPOLOGY_ALL", "cmd_SHOW_OSPF_STATE",
  "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB", "pipe_proto_start",
  "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode",
  "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,    40,    41,    59,    58,   123,   125,    44,    63,
      91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   322,   323,   323,   324,   324,   325,   325,   325,   326,
     326,   327,   327,   327,   327,   327,   327,   328,   328,   329,
     330,   330,   331,   331,   332,   333,   333,   334,   335,   335,
     336,   336,   336,   337,   337,   338,   338,   339,   339,   339,
     339,   339,   339,   339,   339,   339,   340,   340,   341,   341,
     341,   341,   342,   342,   342,   342,   343,   344,   345,   346,
     347,   347,   348,   349,   349,   349,   349,   350,   351,   351,
     352,   353,   354,   354,   354,   355,   356,   356,   357,   357,
     357,   357,   358,   359,   360,   360,   361,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   362,   362,   362,   362,
     363,   364,   364,   365,   366,   366,   366,   367,   367,   368,
     369,   369,   370,   371,   371,   371,   372,   373,   374,   374,
     374,   375,   375,   376,   376,   376,   376,   376,   376,   377,
     377,   377,   378,   378,   379,   379,   380,   380,   381,   381,
     382,   382,   383,   384,   384,   384,   384,   384,   384,   385,
     386,   387,   388,   389,   389,   390,   391,   392,   393,   393,
     393,   393,   393,   393,   393,   393,   393,   393,   393,   393,
     394,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   404,   404,   405,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   415,   415,   416,   416,
     416,   418,   417,   419,   420,   420,   420,   420,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   421,   422,   422,
     423,   423,   424,   425,   425,   426,   427,   427,   428,   430,
     429,   431,   431,   432,   432,   433,   433,   434,   435,   435,
     435,   435,   436,   436,   436,   436,   436,   437,   438,   438,
     438,   439,   439,   440,   441,   441,   441,   441,   442,   442,
     442,   443,   443,   443,   443,   444,   444,   444,   444,   445,
     445,   446,   446,   447,   448,   448,   448,   448,   449,   449,
     450,   450,   450,   451,   451,   452,   452,   453,   453,   453,
     453,   453,   454,   454,   454,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   456,   456,   457,   458,
     459,   460,   460,   460,   460,   460,   460,   460,   460,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   461,   461,
     461,   461,   461,   461,   462,   462,   462,   462,   462,   462,
     463,   464,   464,   464,   465,   465,   466,   466,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   468,   469,   469,   469,   469,   469,
     469,   469,   469,   469,   469,   469,   469,   469,   469,   469,
     469,   469,   469,   469,   469,   469,   469,   469,   469,   469,
     469,   469,   469,   469,   469,   469,   469,   469,   469,   469,
     469,   469,   469,   469,   469,   469,   470,   471,   471,   472,
     472,   472,   472,   472,   472,   473,   474,   475,   475,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   477,   476,
     478,   476,   476,   476,   476,   479,   479,   480,   481,   481,
     482,   482,   482,   483,   483,   484,   484,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   486,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   488,   488,
     489,   490,   491,   491,   491,   492,   492,   493,   493,   494,
     495,   496,   497,   497,   498,   498,   499,   500,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   510,
     510,   510,   510,   511,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   513,   513,   513,
     514,   514,   514,   514,   514,   515,   515,   515,   516,   516,
     517,   517,   518,   519,   520,   521,   521,   521,   521,   521,
     522,   523,   523,   524,   524,   525,   525,   525,   525,   525,
     525,   525,   526,   527,   527,   527,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   528,   528,   528,   528,
     528,   528,   528,   528,   528,   528,   528,   528,   528,   528,
     528,   528,   528,   528,   528,   528,   528,   528,   528,   528,
     528,   528,   528,   528,   528,   528,   528,   528,   528,   528,
     528,   528,   528,   529,   529,   529,   529,   529,   529,   529,
     529,   530,   530,   530,   530,   531,   531,   531,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     2,     0,
       1,     2,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     1,     1,
       1,     1,     2,     4,     3,     3,     3,     3,     4,     2,
       0,     1,     2,     2,     3,     2,     3,     2,     3,     3,
       3,     4,     1,     1,     1,     4,     0,     2,     2,     2,
       1,     1,     2,     1,     0,     1,     0,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     1,     1,     1,
       1,     3,     3,     0,     1,     1,     2,     0,     1,     3,
       1,     3,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     3,     3,     2,     2,
       1,     1,     4,     3,     3,     3,     3,     3,     3,     3,
       4,     1,     1,     1,     0,     1,     3,     3,     3,     3,
       4,     4,     4,     4,     2,     1,     1,     1,     1,     0,
       1,     0,     4,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     0,     3,
       1,     3,     1,     1,     1,     2,     3,     2,     4,     0,
       5,     0,     1,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     5,    11,     1,     1,     1,     2,     1,     7,     9,
       7,     1,     1,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     2,     2,
       2,     0,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     5,     7,     0,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     4,     1,     1,     1,     1,     2,
       2,     3,     3,     6,     3,     3,     3,     3,     5,     6,
       6,     6,     6,     4,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     3,     1,     3,     0,     1,     4,     6,
       4,     3,     5,     5,     4,     6,     3,     2,     5,     5,
       8,     8,     8,     8,     2,     3,     3,     5,     6,     6,
       6,     4,     4,     5,     6,     6,     5,     3,     4,     5,
       5,     5,     5,     4,     4,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     8,     6,     6,     5,     4,     5,
       4,     5,     4,     5,     5,     5,     2,     3,     3,     1,
       2,     2,     4,     2,     1,     2,     4,     0,     3,     2,
       1,     2,     3,     3,     3,     3,     2,     3,     0,     5,
       0,     5,     2,     2,     1,     4,     1,     1,     0,     3,
       2,     2,     2,     4,     1,     0,     3,     0,     2,     2,
       3,     2,     2,     3,     2,     2,     2,     1,     3,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     3,     2,     3,     3,
       4,     2,     2,     2,     3,     3,     3,     1,     0,     2,
       3,     1,     0,     1,     2,     0,     2,     1,     1,     2,
       3,     0,     0,     3,     0,     3,     3,     1,     0,     4,
       6,     6,     6,     7,     6,     7,     6,     2,     3,     3,
       5,     4,     4,     2,     3,     3,     4,     4,     4,     5,
       5,     4,     3,     4,     4,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     2,     0,     3,
       0,     3,     0,     3,     2,     3,     3,     5,     5,     3,
       2,     2,     3,     1,     2,     3,     3,     3,     3,     2,
       2,     2,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    60,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,   308,   593,   594,
     595,   596,   597,    84,    84,   598,   599,   600,     0,   602,
      84,    86,   603,   604,   605,    84,    86,    84,    86,    84,
      86,    84,    86,    84,    86,     5,   601,    86,    86,   195,
     197,   196,     0,    61,    60,     0,    59,     0,     0,     0,
       0,   194,   199,     0,     0,     0,   158,   154,   154,   154,
       0,     0,     0,     0,     0,     0,     0,   183,   182,   181,
     184,     0,     0,     0,     0,    30,    29,    32,     0,     0,
       0,    51,    50,    49,    48,     0,     0,    82,     0,   201,
      76,     0,     0,   229,   291,   295,   304,   301,   237,   310,
     298,     0,     0,   294,   308,   338,     0,   296,   297,     0,
       0,     0,     0,   308,     0,   299,   300,   305,   336,   337,
       0,   335,   203,    85,     0,     0,    62,    67,   112,   384,
     426,   537,   543,   574,     0,     0,     0,     0,     0,    16,
     116,     0,     0,     0,     0,   645,     0,     0,     0,     0,
       0,    16,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      16,     0,     0,     0,     0,     0,     0,     0,   646,     0,
       0,     0,    16,     0,    16,   647,   429,     0,     0,   434,
       0,     0,     0,   648,     0,     0,   572,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   649,     0,     0,   137,
     141,     0,     0,     0,     0,   650,     0,     0,     0,     0,
      16,     0,    16,     0,   643,     0,     0,     0,     0,    26,
     644,     0,     0,   119,   118,     0,     0,     0,    57,     0,
       0,   189,   130,   129,     0,     0,   198,   200,   199,     0,
     155,     0,   150,   149,     0,   153,     0,   154,   154,   154,
     154,   154,     0,     0,   178,   179,   175,   173,   174,   176,
     177,   185,     0,   186,   187,   188,     0,     0,    31,    33,
       0,     0,   101,     6,     8,   308,   102,    52,     0,    56,
      72,    73,    74,     0,   218,     0,    47,     0,     0,   291,
     310,   291,   308,   291,   291,     0,   283,     0,   308,     0,
       0,     0,   294,   294,     0,   333,   308,   308,   308,   308,
     308,   254,   255,     0,   257,     0,     0,   241,   239,   308,
     238,   240,   263,   261,   262,   269,     0,   274,   278,     0,
     661,   658,   659,   311,   660,   312,   313,   314,   315,   316,
     317,   318,   663,   666,   665,   662,   664,   667,   668,   669,
     672,   670,   671,   673,   674,   675,   676,   677,   678,   339,
     340,   308,   308,   308,   308,   308,   308,   308,   308,   308,
     308,   308,   308,   308,     0,   651,   655,   113,    89,   100,
      93,     0,    87,    12,    14,    13,    15,    11,    88,   103,
      98,   218,    99,   308,    91,    97,    92,    95,    90,   114,
     115,   385,     0,     0,     0,     0,     0,     0,     0,    16,
       0,    17,    18,     0,     0,     0,     0,     0,     0,   397,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
      16,     0,    16,     0,    16,     0,    16,     0,     0,    16,
      16,   386,   427,   435,   430,   433,   431,   428,   437,   538,
       0,     0,     0,   539,   544,   103,     0,   142,     0,   138,
     559,   557,   558,     0,     0,     0,     0,     0,     0,     0,
       0,   545,   552,   143,   575,     0,   580,     0,    16,   576,
     590,     0,   589,     0,   591,     0,   579,     0,    63,     0,
      65,    16,   653,   654,   652,     0,    25,     0,   657,   656,
     124,   123,   125,   127,   128,   126,     0,   121,   192,    58,
     190,   191,   134,   135,     0,   132,   193,     0,   151,   156,
     157,   164,     0,     0,   171,   218,   165,   168,   169,     0,
     170,   159,     0,   163,   172,   528,   528,   528,   154,   528,
     154,   528,   529,   592,   180,     0,     0,    28,    37,    38,
      39,    40,    41,    42,    43,    44,    45,     0,    35,    27,
       0,     0,    54,    55,    71,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,     0,     0,     0,
     202,   222,    80,    81,     0,     0,    75,    77,    46,     0,
     218,   287,   288,     0,   289,   290,   285,   273,   364,   367,
       0,   346,     0,   347,   292,   293,   286,     0,     0,     0,
       0,     0,   256,   308,   319,   308,   250,   248,     0,     0,
     247,     0,     0,   302,   275,   276,     0,     0,   303,   331,
     329,   327,   324,   325,   326,   328,   330,   332,   320,   321,
     322,   323,   341,     0,   342,   344,   345,    94,   107,   110,
     117,   223,   224,    96,   225,     0,     0,   420,   422,     0,
      16,    16,     0,     0,     0,     0,     0,     0,     0,     0,
     398,     0,     0,     0,     0,     0,     0,   391,     0,   392,
       0,   418,     0,     0,     0,     0,     0,     0,     0,   403,
     404,     0,     0,     0,     0,     0,   541,   542,   570,   556,
     547,     0,     0,   551,   546,   548,     0,     0,   554,   555,
     553,     0,     0,     0,     0,     0,     0,    19,     0,     0,
     586,   585,   588,     0,   583,   587,    70,    64,    66,    68,
      21,    20,    69,   120,     0,   131,     0,   152,   161,   167,
     162,   160,   166,   527,     0,     0,     0,   528,     0,   528,
       0,    10,     9,    34,     0,     7,    53,   217,   216,   218,
     308,    78,    79,   227,   220,     0,   230,   284,   308,   353,
       0,   308,   334,   308,   308,   308,     0,     0,   308,   308,
     308,   237,   264,   270,     0,     0,   279,   308,   108,     0,
     103,     0,     0,   421,     0,     0,   417,   411,   387,     0,
       0,   393,     0,   396,     0,   399,   410,   409,   405,     0,
       0,   419,   408,   400,   401,   402,   423,   424,   407,   406,
     425,   432,   521,    16,     0,    16,   448,     0,     0,   450,
     440,    16,   436,     0,   454,   464,   540,   568,   573,   136,
     138,   549,   550,     0,     0,     0,     0,     0,   140,    22,
      23,   578,   577,   581,     0,   584,   122,   133,   531,   530,
     536,     0,   532,     0,   534,    36,   219,     0,   357,     0,
     358,   359,     0,   308,   355,   356,   354,   308,   308,     0,
     308,     0,     0,   308,   233,     0,   226,   365,   348,     0,
       0,     0,     0,   308,   306,   249,   247,     0,     0,   253,
       0,     0,   104,   105,   109,   111,   413,     0,   415,   416,
     388,   389,   395,   394,   412,   390,   103,   453,   441,     0,
       0,    16,     0,   439,     0,     0,   457,   452,   456,     0,
       0,   446,   438,   465,   565,   139,   143,    24,     0,     0,
       0,     0,   582,   533,   535,   308,   308,   308,   308,     0,
       0,     0,   228,   234,     0,     0,   377,   360,   362,     0,
     221,   352,   350,   351,   349,     0,   251,   308,     0,   343,
     106,     0,   524,   443,   444,   442,   445,   508,   478,   458,
     508,   447,   467,     0,     0,   571,     0,   148,   143,   143,
     143,   143,     0,     0,     0,     0,   371,   308,   280,   308,
     308,     0,   308,   376,   307,     0,     0,     0,   277,   414,
     522,   526,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   477,     0,   566,   560,   561,   562,   563,   564,
     567,   569,   144,   145,   146,   147,   370,   309,   374,     0,
     308,   368,   235,     0,     0,     0,     0,     0,     0,     0,
       0,   363,   308,   260,   308,   258,     0,   449,   511,   509,
     512,    16,     0,    16,   455,     0,   451,   471,   469,   468,
       0,     0,   472,   474,   475,   476,   466,     0,     0,   308,
     308,   242,   246,   244,   308,   378,   245,   267,   265,   266,
     271,     0,   373,   372,   308,   308,   308,   308,   379,     0,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   525,   507,     0,
     513,     0,     0,   461,   462,   460,   459,   470,   473,   375,
     236,   369,   282,   247,     0,   308,     0,     0,     0,     0,
       0,   308,   259,   515,   483,   497,   479,   482,   480,     0,
     495,     0,   484,   486,   487,   488,   489,   490,   491,   492,
     493,   501,   502,   503,    16,   481,    16,     0,     0,   523,
     514,   510,   243,   308,   268,   281,   272,     0,     0,     0,
       0,     0,     0,   494,   485,   496,   498,   504,   505,   506,
     499,     0,   383,   381,   382,   380,   252,     0,   500,   516,
     517,   518,     0,   519,   520
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   457,    69,   458,   545,   801,   802,   787,
    1008,   567,    70,   338,   138,   341,   627,   628,    71,   145,
     146,    72,    16,    17,    18,   105,    73,   285,    74,   291,
     286,    75,   353,    76,   355,   657,    77,    78,   184,   206,
     464,   450,    79,   718,   974,   859,   719,   720,    80,    81,
     459,   207,   296,   576,   577,   305,   584,   585,   268,   771,
     269,   270,   784,    19,    20,    21,    22,   316,    23,    24,
      25,   314,   602,    26,    27,    28,    29,    30,    31,    32,
      33,    34,   130,   332,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   102,   309,    82,   354,    83,   647,   648,
     649,   835,   722,   723,   465,   660,   651,    84,   358,   949,
     950,  1111,   175,   392,  1157,   687,   688,   393,   968,   689,
     394,   395,  1160,   396,  1161,   176,   398,   399,  1113,   364,
     177,   365,   374,   178,   179,   180,   952,   181,   429,   966,
     953,  1028,  1029,   669,   670,   954,    85,    86,    87,    88,
     247,   248,   249,   764,   903,   994,   999,   997,   998,  1083,
    1135,   904,  1052,  1093,   905,  1189,  1082,  1129,  1130,  1192,
    1252,  1269,  1270,  1271,   986,  1126,  1081,   987,   814,    44,
      45,    46,    47,    48,    49,    50,    51,    89,    90,    91,
      92,   533,  1100,  1056,  1004,   908,   525,   526,    93,    94,
     277,   794,   795,   278,    52,    95,    53,    96,    97,    98,
     430
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -971
static const yytype_int16 yypact[] =
{
     123,  1977,   111,   155,   564,   279,   132,   549,   564,   150,
     519,   794,   566,   564,   564,   564,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,   158,   603,   288,   408,
     180,   143,  -971,   208,   134,   135,   233,  1097,  -971,  -971,
    -971,  -971,  -971,   240,   240,  -971,  -971,  -971,   363,  -971,
     240,  1975,  -971,  -971,  -971,   240,  1753,   240,  1794,   240,
    1888,   240,  1629,   240,   752,  -971,  -971,  1709,  1935,  -971,
    -971,  -971,    28,  -971,   276,   311,  -971,   564,   564,   374,
      42,  -971,   635,    59,   406,   417,  -971,   337,   615,   337,
     435,   468,   480,   496,   500,   514,   517,  -971,  -971,  -971,
     428,   568,   579,   588,   505,  -971,   497,  -971,    -1,    28,
      90,  -971,  -971,  -971,  -971,   103,   293,  -971,   334,  -971,
    -971,   300,    42,  -971,    68,  -971,  -971,  -971,   592,   305,
    -971,   449,    58,    12,  1097,  -971,   317,  -971,  -971,   319,
     324,   328,   347,   647,   156,  -971,  -971,  -971,  -971,  -971,
    1647,  -971,  2211,  -971,   345,   355,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,   387,    28,   689,   638,    90,   245,
    -971,   415,   415,   692,    42,  -971,   405,   410,   433,   195,
     724,   245,   544,   574,    26,   662,    73,   526,   704,   593,
     717,    71,   597,   590,   395,   591,   594,   353,   581,   578,
     245,   575,   584,   580,   -14,   -25,   614,   577,  -971,   508,
     495,   334,   245,    90,   245,  -971,  -971,   510,   503,  -971,
     509,   761,   352,  -971,   527,   533,  -971,   813,    90,   535,
     -29,    90,    90,   777,   780,   101,  -971,   538,   540,  -971,
     539,   545,   526,   795,   600,  -971,   550,   487,   552,   797,
     245,   806,   245,   807,  -971,   560,   561,   563,   815,   862,
    -971,   569,   573,  -971,  -971,   643,   885,   888,  -971,   889,
     891,  -971,  -971,  -971,   215,   894,  -971,  -971,   660,   895,
    -971,   897,  -971,  -971,  2076,  -971,   900,   337,   337,   337,
     198,   322,   904,   905,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,   907,  -971,  -971,  -971,    80,   892,  -971,  -971,
    1162,   599,  -971,  -971,  -971,  1097,  -971,    90,   668,  -971,
    -971,  -971,  -971,   613,  2148,   184,  -971,   616,   602,    68,
    -971,    68,  1097,    68,    68,   922,  -971,   896,   735,   912,
     764,   917,    12,    12,   926,   914,  1097,  1097,  1097,  1097,
    1097,  -971,  -971,   942,  -971,   640,    92,  -971,  -971,   559,
    -971,  -971,   953,  -971,  -971,  -971,   104,    23,  -971,   124,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  1097,  1097,  1097,  1097,  1097,  1097,  1097,  1097,  1097,
    1097,  1097,  1097,  1097,   362,  -971,  -971,  -971,  -971,  -971,
    -971,   334,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  2069,  -971,  1097,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,   898,   899,   649,   651,    90,   918,   740,   245,
     526,  -971,  -971,    90,   785,   786,    90,   909,    90,  -971,
     661,   913,   784,    90,    90,   245,   916,   667,   910,   670,
     245,   671,   245,   371,   245,   689,   245,   673,   677,   245,
     245,  -971,  -971,  -971,  -971,  -971,   773,  -971,  -971,  -971,
     975,   681,   682,  -971,  -971,  -971,   683,  -971,   684,   920,
    -971,  -971,  -971,   686,   687,   695,    90,    90,   696,   698,
     705,  -971,  -971,   310,  -971,    14,  -971,   689,   245,  -971,
    -971,   411,  -971,   526,  -971,   830,  -971,    90,  -971,    90,
    -971,   245,  -971,  -971,  -971,    90,  -971,   526,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,   429,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,   440,  -971,  -971,  1018,  -971,  -971,
    -971,  -971,  1003,  1009,  -971,  2069,  -971,  -971,  -971,   526,
    -971,  -971,  1011,  -971,  -971,  1015,  1015,  1015,   337,  1015,
     337,  1015,  -971,  -971,  -971,   722,   723,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,   452,  -971,  -971,
    1297,  1020,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,    93,   730,   733,
    -971,  -971,  -971,  -971,   526,    90,  -971,  -971,  -971,  1773,
    2148,  -971,  -971,  1322,  -971,  -971,  -971,  -971,   221,  -971,
     725,  -971,  1024,  -971,  -971,  -971,  -971,   389,  1347,   425,
     450,   482,  -971,  1097,  -971,  1097,  -971,  1045,   736,   738,
    1297,   168,   253,  -971,  -971,  -971,  1038,  1041,  -971,  2222,
    2222,  2222,  2248,  2248,  2222,  2222,  2222,  2222,   713,   713,
     914,   914,  -971,   758,  -971,  -971,  -971,  -971,  1044,  -971,
     755,  -971,  -971,  -971,  2211,    90,    90,  -971,  -971,   760,
     245,   245,   765,   767,   778,    90,    90,   779,    90,   781,
    -971,    90,   782,   787,   788,   789,    90,  -971,   334,  -971,
     792,  -971,   793,   804,   805,   808,   811,   816,   818,  -971,
    -971,   820,   821,    90,  1789,   822,  -971,  -971,   -13,  -971,
    -971,   791,   823,  -971,  -971,  -971,   824,   831,  -971,  -971,
    -971,    90,   380,   438,   803,    90,   526,  -971,   832,   833,
    -971,  -971,  -971,   526,   812,   830,  -971,  -971,  -971,  -971,
      14,  -971,  -971,  -971,   643,  -971,   215,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  1106,  1108,  1118,  1015,  1124,  1015,
    1126,  -971,  -971,  -971,  1162,  -971,  -971,  -971,  -971,  2148,
     551,  -971,  -971,  -971,   834,   836,  -971,  -971,  1097,  -971,
    1123,  1097,  -971,  1097,  1097,  1097,   524,  1372,  1097,   819,
    1097,  -971,  -971,  -971,   844,   592,  -971,  1097,  -971,   650,
    -971,   837,   845,  -971,   851,   852,  -971,  -971,  -971,   856,
     859,  -971,   860,  -971,   861,  -971,  -971,  -971,  -971,   871,
     872,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,   245,    -7,   144,  -971,   915,   526,  -971,
    -971,   185,  -971,   874,  -971,   817,  -971,  -971,  -971,  -971,
     920,  -971,  -971,   875,  1171,  1171,  1171,  1171,  -971,  -971,
    -971,  -971,  -971,  -971,    90,   812,  -971,  -971,  -971,  -971,
    -971,  1187,  -971,  1197,  -971,  -971,  -971,    13,  -971,  1179,
    -971,  -971,   911,  1097,  -971,  -971,  -971,  1097,  1097,   902,
       7,  1647,   908,   906,  -971,  2148,  -971,  -971,  -971,  1402,
    1427,  1453,  1478,  1097,  -971,  -971,  2211,   923,   903,  2211,
    1209,  1503,   526,  -971,  -971,  -971,  -971,    90,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,    90,
      90,   245,    90,  -971,   919,   334,  -971,  -971,   928,   929,
      90,  -971,  -971,  -971,     1,  -971,   310,  -971,   924,   933,
     935,   936,  -971,  -971,  -971,  1097,   735,  1097,  -971,  1132,
    2171,    47,  -971,  -971,  1190,   359,  -971,  2211,   943,   948,
    -971,  -971,  -971,  -971,  -971,  1528,  1218,   998,   947,  -971,
    -971,   951,   308,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,   536,    90,   262,  -971,   955,  -971,   310,   310,
     310,   310,  1170,   957,  1205,  1518,  -971,   932,  -971,  1097,
    1097,   441,   906,  -971,  -971,   934,   972,    10,  -971,  -971,
    -971,  -971,     0,   -51,    19,    90,    90,    90,  1096,   107,
      27,  -971,  -971,   981,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,   984,
     551,  1146,  -971,    30,  1231,  1264,   987,   988,   989,   990,
     997,  -971,  1097,  -971,  1097,  -971,  1869,  -971,  -971,  -971,
    -117,   245,    90,   245,  -971,   999,  -971,  -971,  -971,  -971,
      90,    90,  -971,  -971,  -971,  -971,  -971,  1000,   986,   932,
      15,  -971,  -971,  -971,   559,  -971,  -971,  1305,  -971,  -971,
    -971,   197,  -971,  -971,  1097,  1097,  1097,  1097,  -971,  1010,
     991,  1001,    90,   245,    90,    90,    90,  1117,    90,   243,
    1023,    83,  1060,    90,  1055,  1061,  1054,  -971,  -971,  1025,
    -971,    90,  1026,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  1557,   115,    15,   174,  1589,  1614,  1639,
    1664,  1097,  -971,  -971,  -971,  -971,  -971,  -971,  -971,    90,
    -971,    90,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,   245,  -971,   245,    45,    90,  -971,
    -971,  -971,  -971,  1097,  -971,  -971,  -971,  1027,  1028,  1029,
    1039,  1047,    11,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  1557,  -971,  -971,  -971,  -971,  -971,   -72,  -971,  -971,
    -971,  -971,  1048,  -971,  -971
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -971,  -971,  -971,  -133,  -971,  -202,  -213,  -270,  -584,  -971,
    -227,  -971,  -971,  -971,  -971,  -971,  -971,   513,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  1234,  -971,  -971,  -971,  -971,
    -971,  -971,  -235,  -971,  -971,  -971,  -971,  -971,   854,   608,
    1150,  -411,  -971,  -971,  -971,  -971,   501,  -520,  -971,  -971,
    -971,  -971,   -26,  -971,   562,    53,  -971,   557,  -959,   454,
    -517,  -971,  -518,  -971,  -971,  -971,  -971,  -108,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  1076,  1057,  -971,  -971,  -971,  -971,  -639,
     548,   412,  1014,   783,  1071,  -971,   726,  -971,  -971,  -944,
    -971,   238,  -173,   697,   186,  -832,   542,  -951,  -970,  1216,
    -943,   700,   187,  -971,  -971,  -166,   706,  -971,  -971,  -971,
    -971,   376,   400,  -971,  -971,  -816,  -971,   286,   451,   -67,
    -971,  -971,   333,   570,   390,  -843,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,   357,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -122,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -971,   620,  -971,  -971,  -971,  -971,  -971,  -971,  -971,  -971,
    -867
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -367
static const yytype_int16 yytable[] =
{
     182,   391,   546,   484,   485,   768,   513,   346,   397,   475,
     322,   323,   772,  -232,   951,   811,   965,  1124,   481,   482,
     834,  -231,  -232,  -232,  -232,  -232,   937,   372,   501,  1267,
    -231,  -231,  -231,  -231,   937,  1015,  1150,   481,   482,   339,
     514,   390,   516,   785,   601,  1151,  1152,  1153,   851,   694,
     695,   507,   530,   938,   505,   431,   432,   433,   434,   435,
     343,   938,   310,   293,   344,   452,  1131,  1077,   294,   436,
     437,   438,   439,   440,   441,   442,   443,   302,   558,   444,
     560,   939,   303,   359,  1025,   370,   343,   360,   490,   939,
     344,   481,   482,  1092,   757,   343,   361,   375,   615,   344,
     431,   432,   433,   434,   435,   343,   386,  1023,  1143,   344,
     515,    54,   827,   342,   436,   437,   438,   439,   440,   441,
     442,   443,   343,   347,   444,   528,   344,     1,   534,   535,
    1151,  1152,  1153,   851,   951,   106,   788,   940,   941,   942,
     943,   944,   945,   946,   478,   940,   941,   942,   943,   944,
     945,   946,  1190,   111,  1170,   151,   348,   947,    55,   343,
     948,  1191,  1158,   344,  1231,   947,  1148,  1188,   948,   448,
    1159,   343,   387,   388,   158,   344,   311,   134,   453,   454,
     455,   456,   506,   343,   387,   388,   851,   344,    56,  1151,
    1152,  1153,   851,    57,  1272,  1132,    58,  1053,  1109,   147,
     343,  1141,  1065,   616,   344,   357,  1202,    59,   508,   605,
     606,   607,   609,   611,   631,   148,   717,   315,  1133,   453,
     454,   455,   456,    60,  1112,   152,    61,   149,    62,   431,
     432,   433,   434,   435,   150,    63,   371,   828,   608,   989,
     990,   479,  1273,   436,   437,   438,   439,   440,   441,   442,
     443,   951,   153,   444,    64,  1158,   483,   468,   343,   183,
     343,  1245,   344,  1159,   344,    65,  1134,   733,   343,   387,
     388,   851,   344,   531,   532,   973,   991,   732,   630,   453,
     454,   455,   456,   538,    66,   652,   653,   654,   655,  1144,
    1169,  1054,  1145,   745,   951,   663,   103,   582,   750,   103,
     752,   668,   756,   907,   758,   860,  1112,   761,   762,   677,
     678,   679,   680,   681,   298,   340,   834,  1127,  1055,  -232,
    1257,  1258,   690,  1125,  -232,  1016,   583,  -231,  1268,   786,
     104,   373,  -231,   951,   951,    67,  1136,  1221,   791,   696,
     792,   315,  1154,   729,   295,  1232,   789,  1155,  1233,   350,
     734,   351,   352,   737,   800,   739,   315,   345,   304,   798,
     743,   744,   610,  1068,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   301,   139,  1251,
     362,  1070,   781,   345,   140,   489,   800,   363,  1040,   951,
     992,  1071,   345,   772,   472,   473,   724,   431,   432,   433,
     434,   435,   345,   776,   777,   684,   539,   540,   782,   312,
     685,   436,   437,   438,   439,   440,   441,   442,   443,   345,
     313,   444,   692,   186,   796,   693,   797,  1243,   187,   481,
     482,   790,   799,   431,   432,   433,   434,   435,   324,   188,
     366,   831,   697,   331,   783,   698,   141,   436,   437,   438,
     439,   440,   441,   442,   443,   460,   345,   444,   431,   432,
     433,   434,   435,   189,   142,   914,  1042,   915,   389,    68,
    1000,   325,   436,   437,   438,   439,   440,   441,   442,   443,
     345,   143,   444,   326,   815,   816,  1154,   818,  1057,   820,
     431,   432,   433,   434,   435,   461,   462,   345,   656,   327,
     817,   712,   819,   328,   436,   437,   438,   439,   440,   441,
     442,   443,  1205,   880,   444,  1206,  1095,   329,   391,   391,
     330,  1116,   832,   916,   713,   917,   144,   336,   864,   865,
     714,   397,   431,   432,   433,   434,   435,   715,   716,   838,
    1102,  1103,  1104,  1105,   481,   482,   436,   437,   438,   439,
     440,   441,   442,   443,   337,   345,   444,   345,   390,   390,
    1096,  1097,  1098,  1099,   753,   389,   497,   498,    99,   100,
     937,   333,   154,   920,   155,   156,   157,   158,   159,   160,
     923,   127,   334,    99,   100,   161,   162,   686,   163,   101,
     164,   335,   861,   862,   463,   754,   755,   938,   493,   494,
     190,   128,   869,   870,   101,   872,   129,   349,   874,   112,
     113,  1117,  1118,   879,   356,  1119,   846,   368,   847,  1120,
     257,   367,   550,   135,  1080,   939,   860,   369,   996,   376,
     891,   377,   114,   165,   315,   115,   378,   116,   117,   166,
     379,   259,   136,   521,   522,   366,   800,   366,   913,   366,
     366,   191,   919,   137,   306,   307,   192,   107,   108,   380,
     154,   445,   155,   156,   157,   158,   159,   160,   481,   482,
     972,   446,   193,   161,   162,   308,   163,   551,   164,   306,
     307,   940,   941,   942,   943,   944,   945,   946,  1009,  1010,
    1011,   988,   317,   993,   239,   931,   246,   933,   254,  1001,
     267,   947,   276,   447,   948,   287,   292,   841,   449,   570,
     451,   552,   467,   167,   168,   381,   382,   383,   384,   469,
     553,   165,   632,   633,   470,   571,   572,   166,   169,   170,
     171,   573,   574,   172,   575,   661,  1085,   662,   318,   664,
     665,   442,   443,   843,   474,   444,   803,   804,   154,   471,
     155,   156,   157,   158,   159,   160,   118,   805,   806,   800,
    1048,   161,   162,   476,   163,   480,   164,   486,   844,   823,
     824,   668,   674,   675,   959,   477,   960,   961,   962,   487,
     488,   491,   492,   969,  1086,  1087,  1088,   495,  1089,  1045,
     971,  1012,   496,   195,   499,   500,   502,   554,   555,  1090,
     845,   167,   168,   381,   382,   383,   384,   503,   504,   165,
     509,   512,  1128,   510,  1128,   166,   169,   170,   171,   518,
     196,   172,   511,   197,   517,   519,   198,   199,   119,   520,
     201,   202,   154,   527,   155,   156,   157,   158,   159,   160,
     536,   523,   963,   537,  1041,   161,   162,   686,   163,   524,
     164,   529,   541,  1091,   542,   543,  1043,  1044,   203,  1046,
     120,   544,   204,   547,   549,   557,   556,  1051,  -231,   559,
     272,   173,   548,   561,   562,   563,  1019,   564,   565,   174,
    1020,  1021,   566,   568,   121,   122,  1027,   569,   578,   167,
     168,   579,   580,   165,   581,   319,  1035,   586,   588,   166,
     589,   320,   321,   604,   169,   170,   171,   612,   613,   172,
     614,   667,   617,   629,   659,   123,   124,   125,   126,   154,
    1094,   155,   156,   157,   158,   159,   160,   634,   185,  1193,
     658,  1195,   161,   162,   194,   163,   666,   164,   671,   208,
    1156,   240,   672,   250,   673,   255,   444,   271,  1062,   668,
    1064,   937,  1137,  1138,  1139,   676,  1142,   682,   683,   173,
     691,   725,   726,   727,   730,   728,   731,   174,   735,   736,
     969,  1215,   738,   167,   168,   740,   741,   742,   938,   746,
     165,   747,   748,   273,   749,   751,   166,   759,   169,   170,
     171,   760,   763,   172,   765,   766,   767,   769,   770,  1194,
     773,   774,  1114,  1115,   257,  1027,   939,  1197,  1198,   775,
     778,   154,   779,   155,   156,   157,   158,   159,   160,   780,
     793,   807,   808,   274,   161,   162,  1076,   163,   809,   164,
     812,  1156,  1255,  1156,  1256,   813,   821,   822,   839,  1214,
     826,  1216,  1217,  1218,   829,  1220,  1222,   173,  -366,   830,
    1235,   840,   848,   854,   849,   174,   850,   969,  1240,   855,
     167,   168,   940,   941,   942,   943,   944,   945,   946,   275,
     857,   858,   165,   860,   863,   169,   170,   171,   166,   866,
     172,   867,   947,   109,   110,   948,  1253,  1203,  1254,   131,
     132,   133,   868,   871,   924,   873,   875,  1207,  1208,  1209,
    1210,   876,   877,   878,  1259,  1260,   881,   882,   909,   928,
     154,   929,   155,   156,   157,   158,   159,   160,   883,   884,
     918,   930,   885,   161,   162,   886,   163,   932,   164,   934,
     887,   173,   888,  1003,   889,   890,   906,   910,   911,   174,
     431,   432,   433,   434,   435,   912,   921,   922,   955,   956,
     958,   976,   167,   168,   436,   437,   438,   439,   440,   441,
     442,   443,   970,   977,   444,   978,   979,   169,   170,   171,
     980,   165,   172,   981,   982,   983,  1261,   166,   431,   432,
     433,   434,   435,   299,   300,   984,   985,   995,  1002,  1006,
    1013,  1007,   436,   437,   438,   439,   440,   441,   442,   443,
    1014,  1017,   444,   618,   619,   620,   621,   622,   623,   624,
     625,   626,  1069,   431,   432,   433,   434,   435,   173,  1022,
    -361,  1037,  1026,  1018,  1038,  1075,   174,   436,   437,   438,
     439,   440,   441,   442,   443,  1047,  1036,   444,  1058,   431,
     432,   433,   434,   435,  1049,  1050,  1122,  1059,  1110,  1060,
    1061,   167,   168,   436,   437,   438,   439,   440,   441,   442,
     443,  1072,  1073,   444,  1078,  1079,   169,   170,   171,  1101,
    1107,   172,   431,   432,   433,   434,   435,  1223,  1224,  1225,
    1226,  1227,  1228,  1229,  1230,  1123,   436,   437,   438,   439,
     440,   441,   442,   443,  1140,  1146,   444,  1147,  1149,  1164,
    1165,  1166,  1167,  1200,  1212,   431,   432,   433,   434,   435,
     173,  1168,  1204,  1196,  1199,  1219,  1234,  1213,   174,   436,
     437,   438,   439,   440,   441,   442,   443,  1236,  1211,   444,
     431,   432,   433,   434,   435,  1237,  1238,   935,   297,  1239,
    1241,  1262,  1263,  1264,   436,   437,   438,   439,   440,   441,
     442,   443,   466,  1265,   444,   431,   432,   433,   434,   435,
    1266,   975,  1274,   927,  1005,   587,   926,  1030,   650,   436,
     437,   438,   439,   440,   441,   442,   443,   936,   810,   444,
     431,   432,   433,   434,   435,   603,   836,  1201,   852,   385,
    1244,   967,   853,  1246,   436,   437,   438,   439,   440,   441,
     442,   443,  1024,   856,   444,  1121,  1063,  1084,   957,   173,
     431,   432,   433,   434,   435,   925,     0,   174,     0,     0,
       0,     0,     0,     0,   436,   437,   438,   439,   440,   441,
     442,   443,     0,     0,   444,   431,   432,   433,   434,   435,
       0,     0,     0,     0,     0,     0,  1066,     0,     0,   436,
     437,   438,   439,   440,   441,   442,   443,     0,     0,   444,
       0,   431,   432,   433,   434,   435,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   436,   437,   438,   439,   440,
     441,   442,   443,     0,  1106,   444,   431,   432,   433,   434,
     435,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     436,   437,   438,   439,   440,   441,   442,   443,     0,     0,
     444,   431,   432,   433,   434,   435,     0,     0,     0,  1108,
       0,     0,     0,   400,     0,   436,   437,   438,   439,   440,
     441,   442,   443,     0,     0,   444,   431,   432,   433,   434,
     435,     0,     0,     0,     0,  1162,     0,     0,     0,     0,
     436,   437,   438,   439,   440,   441,   442,   443,     0,     0,
     444,     0,     0,     0,     0,   431,   432,   433,   434,   435,
       0,     0,     0,     0,     0,     0,     0,     0,  1163,   436,
     437,   438,   439,   440,   441,   442,   443,   401,   402,   444,
       0,     0,     0,     0,     0,     0,     0,   431,   432,   433,
     434,   435,     0,     0,     0,     0,     0,     0,     0,     0,
     825,   436,   437,   438,   439,   440,   441,   442,   443,     0,
       0,   444,   431,   432,   433,   434,   435,     0,     0,     0,
       0,     0,   404,     0,     0,   837,   436,   437,   438,   439,
     440,   441,   442,   443,     0,     0,   444,   431,   432,   433,
     434,   435,   400,     0,     0,     0,     0,     0,     0,     0,
     842,   436,   437,   438,   439,   440,   441,   442,   443,     0,
     195,   444,   431,   432,   433,   434,   435,     0,     0,     0,
       0,     0,     0,     0,     0,   964,   436,   437,   438,   439,
     440,   441,   442,   443,     0,     0,   444,   196,     0,     0,
     197,     0,     0,   198,   199,     0,   256,   201,   202,     0,
       0,     0,     0,   257,     0,  1031,   401,   402,     0,     0,
     412,   413,   414,   415,   416,   417,   418,   419,   420,     0,
       0,     0,   403,   258,   259,   203,     0,     0,     0,   204,
    1032,     0,     0,     0,     0,     0,     0,   421,   422,     0,
     195,     0,     0,     0,     0,     0,     0,   423,   424,   425,
     426,   404,     0,     0,     0,     0,  1033,     0,     0,   279,
     280,   281,     0,   282,   283,     0,     0,   196,     0,     0,
     197,     0,     0,   198,   199,     0,     0,   201,   202,     0,
       0,  1034,     0,     0,   195,     0,     0,     0,     0,   209,
       0,     0,     0,     0,     0,     0,     0,   405,   406,     0,
     407,   408,   409,   410,   411,   203,  1039,     0,     0,   204,
       0,   196,     0,     0,   197,   427,   428,   198,   199,     0,
       0,   201,   202,     0,     0,   195,     0,   210,     0,   211,
       0,  1074,     0,     0,     0,     0,     0,     0,     0,   412,
     413,   414,   415,   416,   417,   418,   419,   420,     0,   203,
       0,     0,   196,   204,     0,   197,   892,     0,   198,   199,
    1242,   212,   201,   202,     0,     0,   421,   422,     0,   213,
     214,     0,     0,     0,     0,     0,   423,   424,   425,   426,
       0,     0,   260,     0,     0,     0,     0,     0,     0,     0,
     203,     0,  1247,     0,   204,     0,   893,     0,     0,     0,
     635,   636,   637,   638,   639,   640,   641,   215,   642,   643,
     644,   645,   646,   261,   262,   263,   264,  1248,     0,   195,
       0,     0,     0,   265,   216,   217,     0,   218,   219,     0,
     220,   221,   222,     0,   223,     0,   266,   224,   225,     0,
     226,     0,  1249,   257,   427,   428,   196,     0,     0,   197,
       0,     0,   198,   199,   227,   228,   201,   202,     0,   229,
       0,   230,     0,   231,   259,   232,   195,  1250,     0,     0,
     233,     0,     0,   894,   234,   235,     0,   236,   237,     0,
       0,     0,  1171,     0,   203,     0,     0,   288,   204,     0,
       0,     0,     0,   196,     0,     0,   197,     0,     0,   198,
     199,     0,     0,   201,   202,     0,   195,     0,     4,     0,
       0,     0,     0,     0,     0,     0,   284,   289,     0,     0,
       0,     0,   241,   895,     0,     5,     6,   242,     0,   243,
       0,   203,     0,   196,     0,   204,   197,     0,     0,   198,
     199,     0,   200,   201,   202,     0,     0,   896,     0,   897,
       0,     0,     0,     0,     0,     0,   898,     0,   899,  1172,
     238,     0,   900,   901,     0,   244,     0,     0,     0,   590,
       0,   203,     0,     0,     7,   204,   833,     8,   721,     9,
       0,     0,    10,     0,   481,   482,     0,    11,     0,     0,
       0,     0,    12,    13,    14,    15,   902,     0,     0,     0,
       0,   245,     0,  1173,     0,  1174,   591,  1175,  1176,  1177,
    1178,  1179,  1180,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1181,  1182,     0,     0,  1183,     0,     0,     0,
    1184,     0,  1185,     0,   592,     0,     0,     0,     0,   593,
    1186,     0,     0,     0,     0,   594,   595,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   596,   597,
     598,   599,     0,   600,     0,     0,     0,   251,   252,   431,
     432,   433,   434,   435,     0,     0,  1187,     0,     0,     0,
       0,     0,     0,   436,   437,   438,   439,   440,   441,   442,
     443,     0,     0,   444,     0,   253,   635,   636,   637,   638,
     639,   640,   641,     0,   642,   643,   644,   645,   646,   431,
     432,   433,   434,   435,     0,     0,     0,     0,     0,     0,
    -367,  -367,  -367,   436,   437,   438,   439,   440,   441,   442,
     443,     0,     0,   444,  -367,  -367,  -367,  -367,   440,   441,
     442,   443,   290,     0,   444,   463,   431,   432,   433,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     436,   437,   438,   439,   440,   441,   442,   443,     0,     0,
     444,     0,     0,     0,     0,   635,   636,   637,   638,   639,
     640,   641,   205,   642,   643,   644,   645,   646,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1067
};

static const yytype_int16 yycheck[] =
{
      67,   174,   272,   216,   217,   525,   241,   140,   174,   211,
     118,   119,   529,     6,   830,   599,   848,     7,    18,    19,
     659,     6,    15,    16,    17,    18,    19,    15,   230,    18,
      15,    16,    17,    18,    19,    22,     6,    18,    19,    40,
     242,   174,   244,    29,   314,    15,    16,    17,    18,    26,
      27,    76,    81,    46,    68,     8,     9,    10,    11,    12,
      15,    46,     3,    35,    19,   198,   117,  1037,    40,    22,
      23,    24,    25,    26,    27,    28,    29,    35,   280,    32,
     282,    74,    40,    15,   951,    27,    15,    19,   221,    74,
      19,    18,    19,  1052,   505,    15,    28,   164,    18,    19,
       8,     9,    10,    11,    12,    15,   173,   950,    81,    19,
     243,     0,    19,   139,    22,    23,    24,    25,    26,    27,
      28,    29,    15,    20,    32,   258,    19,     4,   261,   262,
      15,    16,    17,    18,   950,     3,   547,   130,   131,   132,
     133,   134,   135,   136,   118,   130,   131,   132,   133,   134,
     135,   136,   269,     3,  1124,    20,    53,   150,     3,    15,
     153,   278,  1113,    19,    81,   150,  1110,  1126,   153,   195,
    1113,    15,    16,    17,    18,    19,   117,    19,    34,    35,
      36,    37,   196,    15,    16,    17,    18,    19,    33,    15,
      16,    17,    18,    38,   266,   246,    41,   196,  1065,    19,
      15,    94,  1018,   336,    19,   152,  1150,    52,   233,   317,
     318,   319,   320,   321,   347,    72,   451,    19,   269,    34,
      35,    36,    37,    68,  1067,    90,    71,    19,    73,     8,
       9,    10,    11,    12,   100,    80,   178,   144,    40,   246,
     247,   215,   314,    22,    23,    24,    25,    26,    27,    28,
      29,  1067,    19,    32,    99,  1206,   183,   204,    15,    19,
      15,  1205,    19,  1206,    19,   110,   317,   480,    15,    16,
      17,    18,    19,   302,   303,   859,   283,   479,   345,    34,
      35,    36,    37,   182,   129,   101,   102,   103,   104,   262,
    1122,   290,   265,   495,  1110,   362,    20,    82,   500,    20,
     502,   368,   504,   316,   506,   318,  1149,   509,   510,   376,
     377,   378,   379,   380,     3,   316,   955,   317,   317,   312,
     275,   276,   389,   313,   317,   312,   111,   312,   317,   315,
      51,   319,   317,  1149,  1150,   180,   317,    94,   551,   316,
     553,    19,   312,   476,   316,   262,   548,   317,   265,    15,
     483,    17,    18,   486,   567,   488,    19,   312,   316,   561,
     493,   494,    40,   316,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,     3,    90,  1211,
     312,    22,    72,   312,    96,   314,   599,   319,   972,  1205,
     246,    32,   312,   910,   199,   200,   463,     8,     9,    10,
      11,    12,   312,   536,   537,   313,   305,   306,    98,     3,
     318,    22,    23,    24,    25,    26,    27,    28,    29,   312,
       3,    32,   318,    60,   557,   321,   559,   312,    65,    18,
      19,    20,   565,     8,     9,    10,    11,    12,     3,    76,
     154,   654,   318,    15,   134,   321,    38,    22,    23,    24,
      25,    26,    27,    28,    29,    40,   312,    32,     8,     9,
      10,    11,    12,   100,    56,    85,   986,    87,   312,   314,
     285,     3,    22,    23,    24,    25,    26,    27,    28,    29,
     312,    73,    32,     3,   606,   607,   312,   609,  1006,   611,
       8,     9,    10,    11,    12,    80,    81,   312,   314,     3,
     608,   139,   610,     3,    22,    23,    24,    25,    26,    27,
      28,    29,   315,   748,    32,   318,   254,     3,   691,   692,
       3,    80,   655,    85,   162,    87,   118,    22,   730,   731,
     168,   697,     8,     9,    10,    11,    12,   175,   176,   318,
    1058,  1059,  1060,  1061,    18,    19,    22,    23,    24,    25,
      26,    27,    28,    29,    57,   312,    32,   312,   691,   692,
     298,   299,   300,   301,   193,   312,   213,   214,    19,    20,
      19,     3,    13,   786,    15,    16,    17,    18,    19,    20,
     793,    15,     3,    19,    20,    26,    27,    28,    29,    40,
      31,     3,   725,   726,   179,   224,   225,    46,   203,   204,
     237,    35,   735,   736,    40,   738,    40,   314,   741,    90,
      91,   170,   171,   746,   314,   174,   683,   312,   685,   178,
      84,    29,   135,    20,   316,    74,   318,   178,   898,   312,
     763,   312,   113,    74,    19,   116,   312,   118,   119,    80,
     312,   105,    39,   291,   292,   359,   859,   361,   781,   363,
     364,   288,   785,    50,    19,    20,   293,   108,   109,   312,
      13,   316,    15,    16,    17,    18,    19,    20,    18,    19,
      20,   316,   309,    26,    27,    40,    29,   190,    31,    19,
      20,   130,   131,   132,   133,   134,   135,   136,   915,   916,
     917,   893,    77,   895,    86,   817,    88,   819,    90,   901,
      92,   150,    94,   316,   153,    97,    98,   318,    19,    66,
      72,   224,    20,   154,   155,   156,   157,   158,   159,   314,
     233,    74,    54,    55,   314,    82,    83,    80,   169,   170,
     171,    88,    89,   174,    91,   359,   200,   361,   123,   363,
     364,    28,    29,   318,    20,    32,   317,   318,    13,   316,
      15,    16,    17,    18,    19,    20,   237,   317,   318,   972,
     995,    26,    27,   219,    29,   103,    31,    63,   318,   317,
     318,   838,   372,   373,   841,   201,   843,   844,   845,   186,
      63,   184,   192,   850,   248,   249,   250,   196,   252,   991,
     857,   924,   198,    41,   213,   217,   221,   310,   311,   263,
     318,   154,   155,   156,   157,   158,   159,   223,   228,    74,
     196,   316,  1082,   236,  1084,    80,   169,   170,   171,   316,
      68,   174,   314,    71,   314,   316,    74,    75,   309,    68,
      78,    79,    13,    20,    15,    16,    17,    18,    19,    20,
      63,   314,   318,    63,   977,    26,    27,    28,    29,   316,
      31,   316,   314,   317,   314,   316,   989,   990,   106,   992,
      66,   316,   110,    68,   314,    68,   314,  1000,   317,    63,
     118,   312,   272,    66,   314,   314,   943,   314,    63,   320,
     947,   948,    20,   314,    90,    91,   953,   314,     3,   154,
     155,     3,     3,    74,     3,   280,   963,     3,     3,    80,
       3,   286,   287,     3,   169,   170,   171,     3,     3,   174,
       3,    15,    20,   314,   312,   121,   122,   123,   124,    13,
    1053,    15,    16,    17,    18,    19,    20,   314,    74,  1131,
     314,  1133,    26,    27,    80,    29,    14,    31,    26,    85,
    1113,    87,   178,    89,    27,    91,    32,    93,  1015,  1016,
    1017,    19,  1085,  1086,  1087,    29,  1089,    15,   318,   312,
       7,    63,    63,   314,    46,   314,   226,   320,   183,   183,
    1037,  1173,    63,   154,   155,   314,    63,   193,    46,    63,
      74,   314,    72,   231,   314,   314,    80,   314,   169,   170,
     171,   314,   219,   174,    19,   314,   314,   314,   314,  1132,
     314,   314,  1069,  1070,    84,  1072,    74,  1140,  1141,   314,
     314,    13,   314,    15,    16,    17,    18,    19,    20,   314,
     190,     3,    19,   271,    26,    27,    28,    29,    19,    31,
      19,  1204,  1234,  1206,  1236,    20,   314,   314,   313,  1172,
      20,  1174,  1175,  1176,   314,  1178,  1179,   312,   313,   316,
    1183,    27,     7,    15,   318,   320,   318,  1124,  1191,    18,
     154,   155,   130,   131,   132,   133,   134,   135,   136,   317,
     312,    27,    74,   318,   314,   169,   170,   171,    80,   314,
     174,   314,   150,     7,     8,   153,  1219,  1154,  1221,    13,
      14,    15,   314,   314,   282,   314,   314,  1164,  1165,  1166,
    1167,   314,   314,   314,  1237,  1238,   314,   314,   317,     3,
      13,     3,    15,    16,    17,    18,    19,    20,   314,   314,
     317,     3,   314,    26,    27,   314,    29,     3,    31,     3,
     314,   312,   314,   316,   314,   314,   314,   314,   314,   320,
       8,     9,    10,    11,    12,   314,   314,   314,   314,   313,
      27,   314,   154,   155,    22,    23,    24,    25,    26,    27,
      28,    29,   318,   318,    32,   314,   314,   169,   170,   171,
     314,    74,   174,   314,   314,   314,  1243,    80,     8,     9,
      10,    11,    12,   107,   108,   314,   314,   272,   314,   314,
       3,    20,    22,    23,    24,    25,    26,    27,    28,    29,
       3,    22,    32,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    22,     8,     9,    10,    11,    12,   312,   317,
     314,   318,   314,   312,    15,     7,   320,    22,    23,    24,
      25,    26,    27,    28,    29,   316,   313,    32,   314,     8,
       9,    10,    11,    12,   316,   316,   312,   314,   316,   314,
     314,   154,   155,    22,    23,    24,    25,    26,    27,    28,
      29,   318,   314,    32,   317,   314,   169,   170,   171,   314,
     313,   174,     8,     9,    10,    11,    12,   254,   255,   256,
     257,   258,   259,   260,   261,   313,    22,    23,    24,    25,
      26,    27,    28,    29,   198,   314,    32,   313,   152,   312,
     312,   312,   312,   317,   313,     8,     9,    10,    11,    12,
     312,   314,     7,   314,   314,   198,   256,   316,   320,    22,
      23,    24,    25,    26,    27,    28,    29,   272,   318,    32,
       8,     9,    10,    11,    12,   274,   282,   824,   104,   314,
     314,   314,   314,   314,    22,    23,    24,    25,    26,    27,
      28,    29,   202,   314,    32,     8,     9,    10,    11,    12,
     313,   860,   314,   806,   910,   308,   804,   955,   354,    22,
      23,    24,    25,    26,    27,    28,    29,   829,   595,    32,
       8,     9,    10,    11,    12,   314,   660,  1149,   691,   173,
    1204,   849,   692,  1206,    22,    23,    24,    25,    26,    27,
      28,    29,   951,   697,    32,  1072,  1016,  1050,   838,   312,
       8,     9,    10,    11,    12,   795,    -1,   320,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,   314,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,   314,
      -1,    -1,    -1,     5,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,   314,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,    22,
      23,    24,    25,    26,    27,    28,    29,    69,    70,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     313,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,   114,    -1,    -1,   313,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      11,    12,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     313,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      41,    32,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   313,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    68,    -1,    -1,
      71,    -1,    -1,    74,    75,    -1,    77,    78,    79,    -1,
      -1,    -1,    -1,    84,    -1,   313,    69,    70,    -1,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,   210,    -1,
      -1,    -1,    85,   104,   105,   106,    -1,    -1,    -1,   110,
     313,    -1,    -1,    -1,    -1,    -1,    -1,   229,   230,    -1,
      41,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,
     242,   114,    -1,    -1,    -1,    -1,   313,    -1,    -1,    60,
      61,    62,    -1,    64,    65,    -1,    -1,    68,    -1,    -1,
      71,    -1,    -1,    74,    75,    -1,    -1,    78,    79,    -1,
      -1,   313,    -1,    -1,    41,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,   161,    -1,
     163,   164,   165,   166,   167,   106,   313,    -1,    -1,   110,
      -1,    68,    -1,    -1,    71,   307,   308,    74,    75,    -1,
      -1,    78,    79,    -1,    -1,    41,    -1,    84,    -1,    86,
      -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,   210,    -1,   106,
      -1,    -1,    68,   110,    -1,    71,    77,    -1,    74,    75,
     313,   118,    78,    79,    -1,    -1,   229,   230,    -1,   126,
     127,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,   242,
      -1,    -1,   263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     106,    -1,   313,    -1,   110,    -1,   117,    -1,    -1,    -1,
     137,   138,   139,   140,   141,   142,   143,   164,   145,   146,
     147,   148,   149,   294,   295,   296,   297,   313,    -1,    41,
      -1,    -1,    -1,   304,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,    -1,   317,   194,   195,    -1,
     197,    -1,   313,    84,   307,   308,    68,    -1,    -1,    71,
      -1,    -1,    74,    75,   211,   212,    78,    79,    -1,   216,
      -1,   218,    -1,   220,   105,   222,    41,   313,    -1,    -1,
     227,    -1,    -1,   194,   231,   232,    -1,   234,   235,    -1,
      -1,    -1,   123,    -1,   106,    -1,    -1,    62,   110,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    74,
      75,    -1,    -1,    78,    79,    -1,    41,    -1,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,    92,    -1,    -1,
      -1,    -1,   238,   244,    -1,    58,    59,   243,    -1,   245,
      -1,   106,    -1,    68,    -1,   110,    71,    -1,    -1,    74,
      75,    -1,    77,    78,    79,    -1,    -1,   268,    -1,   270,
      -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,   279,   200,
     317,    -1,   283,   284,    -1,   281,    -1,    -1,    -1,     3,
      -1,   106,    -1,    -1,   107,   110,   313,   110,    19,   112,
      -1,    -1,   115,    -1,    18,    19,    -1,   120,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   317,    -1,    -1,    -1,
      -1,   317,    -1,   244,    -1,   246,    40,   248,   249,   250,
     251,   252,   253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   263,   264,    -1,    -1,   267,    -1,    -1,    -1,
     271,    -1,   273,    -1,    68,    -1,    -1,    -1,    -1,    73,
     281,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,
      94,    95,    -1,    97,    -1,    -1,    -1,   289,   290,     8,
       9,    10,    11,    12,    -1,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,   317,   137,   138,   139,   140,
     141,   142,   143,    -1,   145,   146,   147,   148,   149,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
       8,     9,    10,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    22,    23,    24,    25,    26,    27,
      28,    29,   317,    -1,    32,   179,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,    -1,    -1,   137,   138,   139,   140,   141,
     142,   143,   317,   145,   146,   147,   148,   149,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   323,   324,    41,    58,    59,   107,   110,   112,
     115,   120,   125,   126,   127,   128,   344,   345,   346,   385,
     386,   387,   388,   390,   391,   392,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   501,   502,   503,   504,   505,   506,
     507,   508,   526,   528,     0,     3,    33,    38,    41,    52,
      68,    71,    73,    80,    99,   110,   129,   180,   314,   326,
     334,   340,   343,   348,   350,   353,   355,   358,   359,   364,
     370,   371,   417,   419,   429,   468,   469,   470,   471,   509,
     510,   511,   512,   520,   521,   527,   529,   530,   531,    19,
      20,    40,   415,    20,    51,   347,     3,   108,   109,   415,
     415,     3,    90,    91,   113,   116,   118,   119,   237,   309,
      66,    90,    91,   121,   122,   123,   124,    15,    35,    40,
     404,   415,   415,   415,    19,    20,    39,    50,   336,    90,
      96,    38,    56,    73,   118,   341,   342,    19,    72,    19,
     100,    20,    90,    19,    13,    15,    16,    17,    18,    19,
      20,    26,    27,    29,    31,    74,    80,   154,   155,   169,
     170,   171,   174,   312,   320,   434,   447,   452,   455,   456,
     457,   459,   461,    19,   360,   360,    60,    65,    76,   100,
     237,   288,   293,   309,   360,    41,    68,    71,    74,    75,
      77,    78,    79,   106,   110,   317,   361,   373,   360,    46,
      84,    86,   118,   126,   127,   164,   181,   182,   184,   185,
     187,   188,   189,   191,   194,   195,   197,   211,   212,   216,
     218,   220,   222,   227,   231,   232,   234,   235,   317,   361,
     360,   238,   243,   245,   281,   317,   361,   472,   473,   474,
     360,   289,   290,   317,   361,   360,    77,    84,   104,   105,
     263,   294,   295,   296,   297,   304,   317,   361,   380,   382,
     383,   360,   118,   231,   271,   317,   361,   522,   525,    60,
      61,    62,    64,    65,   317,   349,   352,   361,    62,    92,
     317,   351,   361,    35,    40,   316,   374,   347,     3,   415,
     415,     3,    35,    40,   316,   377,    19,    20,    40,   416,
       3,   117,     3,     3,   393,    19,   389,    77,   123,   280,
     286,   287,   389,   389,     3,     3,     3,     3,     3,     3,
       3,    15,   405,     3,     3,     3,    22,    57,   335,    40,
     316,   337,   374,    15,    19,   312,   325,    20,    53,   314,
      15,    17,    18,   354,   418,   356,   314,   377,   430,    15,
      19,    28,   312,   319,   451,   453,   459,    29,   312,   178,
      27,   178,    15,   319,   454,   461,   312,   312,   312,   312,
     312,   156,   157,   158,   159,   441,   461,    16,    17,   312,
     325,   434,   435,   439,   442,   443,   445,   447,   448,   449,
       5,    69,    70,    85,   114,   160,   161,   163,   164,   165,
     166,   167,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   229,   230,   239,   240,   241,   242,   307,   308,   460,
     532,     8,     9,    10,    11,    12,    22,    23,    24,    25,
      26,    27,    28,    29,    32,   316,   316,   316,   374,    19,
     363,    72,   325,    34,    35,    36,    37,   325,   327,   372,
      40,    80,    81,   179,   362,   426,   362,    20,   377,   314,
     314,   316,   199,   200,    20,   327,   219,   201,   118,   215,
     103,    18,    19,   183,   328,   328,    63,   186,    63,   314,
     325,   184,   192,   203,   204,   196,   198,   213,   214,   213,
     217,   327,   221,   223,   228,    68,   196,    76,   233,   196,
     236,   314,   316,   354,   327,   325,   327,   314,   316,   316,
      68,   291,   292,   314,   316,   518,   519,    20,   325,   316,
      81,   302,   303,   513,   325,   325,    63,    63,   182,   305,
     306,   314,   314,   316,   316,   328,   329,    68,   272,   314,
     135,   190,   224,   233,   310,   311,   314,    68,   327,    63,
     327,    66,   314,   314,   314,    63,    20,   333,   314,   314,
      66,    82,    83,    88,    89,    91,   375,   376,     3,     3,
       3,     3,    82,   111,   378,   379,     3,   416,     3,     3,
       3,    40,    68,    73,    79,    80,    92,    93,    94,    95,
      97,   329,   394,   426,     3,   389,   389,   389,    40,   389,
      40,   389,     3,     3,     3,    18,   325,    20,    41,    42,
      43,    44,    45,    46,    47,    48,    49,   338,   339,   314,
     461,   325,    54,    55,   314,   137,   138,   139,   140,   141,
     142,   143,   145,   146,   147,   148,   149,   420,   421,   422,
     424,   428,   101,   102,   103,   104,   314,   357,   314,   312,
     427,   453,   453,   461,   453,   453,    14,    15,   461,   465,
     466,    26,   178,    27,   454,   454,    29,   461,   461,   461,
     461,   461,    15,   318,   313,   318,    28,   437,   438,   441,
     461,     7,   318,   321,    26,    27,   316,   318,   321,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   461,   461,
     461,   461,   139,   162,   168,   175,   176,   354,   365,   368,
     369,    19,   424,   425,   461,    63,    63,   314,   314,   325,
      46,   226,   327,   328,   325,   183,   183,   325,    63,   325,
     314,    63,   193,   325,   325,   327,    63,   314,    72,   314,
     327,   314,   327,   193,   224,   225,   327,   363,   327,   314,
     314,   327,   327,   219,   475,    19,   314,   314,   369,   314,
     314,   381,   382,   314,   314,   314,   325,   325,   314,   314,
     314,    72,    98,   134,   384,    29,   315,   331,   363,   327,
      20,   328,   328,   190,   523,   524,   325,   325,   327,   325,
     328,   329,   330,   317,   318,   317,   318,     3,    19,    19,
     425,   330,    19,    20,   500,   500,   500,   389,   500,   389,
     500,   314,   314,   317,   318,   313,    20,    19,   144,   314,
     316,   328,   325,   313,   421,   423,   428,   313,   318,   313,
      27,   318,   313,   318,   318,   318,   461,   461,     7,   318,
     318,    18,   435,   443,    15,    18,   448,   312,    27,   367,
     318,   325,   325,   314,   327,   327,   314,   314,   314,   325,
     325,   314,   325,   314,   325,   314,   314,   314,   314,   325,
     354,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   325,    77,   117,   194,   244,   268,   270,   277,   279,
     283,   284,   317,   476,   483,   486,   314,   316,   517,   317,
     314,   314,   314,   325,    85,    87,    85,    87,   317,   325,
     328,   314,   314,   328,   282,   523,   376,   379,     3,     3,
       3,   500,     3,   500,     3,   339,   422,    19,    46,    74,
     130,   131,   132,   133,   134,   135,   136,   150,   153,   431,
     432,   457,   458,   462,   467,   314,   313,   465,    27,   461,
     461,   461,   461,   318,   313,   437,   461,   438,   440,   461,
     318,   461,    20,   330,   366,   368,   314,   318,   314,   314,
     314,   314,   314,   314,   314,   314,   496,   499,   327,   246,
     247,   283,   246,   327,   477,   272,   329,   479,   480,   478,
     285,   327,   314,   316,   516,   381,   314,    20,   332,   332,
     332,   332,   325,     3,     3,    22,   312,    22,   312,   461,
     461,   461,   317,   467,   460,   532,   314,   461,   463,   464,
     423,   313,   313,   313,   313,   461,   313,   318,    15,   313,
     330,   325,   369,   325,   325,   327,   325,   316,   354,   316,
     316,   325,   484,   196,   290,   317,   515,   384,   314,   314,
     314,   314,   461,   466,   461,   457,   314,   151,   316,    22,
      22,    32,   318,   314,   313,     7,    28,   440,   317,   314,
     316,   498,   488,   481,   488,   200,   248,   249,   250,   252,
     263,   317,   380,   485,   325,   254,   298,   299,   300,   301,
     514,   314,   384,   384,   384,   384,   314,   313,   314,   532,
     316,   433,   467,   450,   461,   461,    80,   170,   171,   174,
     178,   464,   312,   313,     7,   313,   497,   317,   329,   489,
     490,   117,   246,   269,   317,   482,   317,   325,   325,   325,
     198,    94,   325,    81,   262,   265,   314,   313,   431,   152,
       6,    15,    16,    17,   312,   317,   434,   436,   439,   442,
     444,   446,   314,   314,   312,   312,   312,   312,   314,   437,
     440,   123,   200,   244,   246,   248,   249,   250,   251,   252,
     253,   263,   264,   267,   271,   273,   281,   317,   380,   487,
     269,   278,   491,   327,   325,   327,   314,   325,   325,   314,
     317,   433,   431,   461,     7,   315,   318,   461,   461,   461,
     461,   318,   313,   316,   325,   327,   325,   325,   325,   198,
     325,    94,   325,   254,   255,   256,   257,   258,   259,   260,
     261,    81,   262,   265,   256,   325,   272,   274,   282,   314,
     325,   314,   313,   312,   436,   431,   444,   313,   313,   313,
     313,   437,   492,   325,   325,   327,   327,   275,   276,   325,
     325,   461,   314,   314,   314,   314,   313,    18,   317,   493,
     494,   495,   266,   314,   314
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 617 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 618 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 631 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 632 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 638 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 642 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 651 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 652 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 653 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 654 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 655 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 656 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 663 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 670 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 678 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 682 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 686 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 693 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 701 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 702 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 708 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 717 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 718 "cf-parse.y"
    { (yyval.t) = bird_name; ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 722 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 727 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 728 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 732 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 733 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 737 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 738 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 742 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 743 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 744 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 745 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 746 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 747 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 748 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 749 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 750 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 756 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); ;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 757 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 766 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; ;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 767 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; ;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 768 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; ;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 769 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 772 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; ;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 773 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 774 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 775 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 787 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 790 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 793 "cf-parse.y"
    { cmd_shutdown(); ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 796 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 805 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 821 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 822 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 826 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 833 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 839 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 852 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 856 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 869 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 882 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 888 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 890 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 909 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 910 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 911 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 912 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 919 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 931 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 937 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 945 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 949 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 950 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 951 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 952 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 953 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 954 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 955 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 956 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 960 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 962 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 963 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 967 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 975 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 976 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 984 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 992 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 993 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 994 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 998 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 999 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 1016 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 1031 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 1046 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 1047 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 1048 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 1053 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 1057 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 1058 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 1059 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 1060 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 1061 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 1062 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 1068 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 1069 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 1070 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 1075 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 1079 "cf-parse.y"
    { (yyval.i) = MD_STATES; ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 1080 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 1101 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 1119 "cf-parse.y"
    { ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 1120 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 1121 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 1122 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 1123 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 1124 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 1133 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 1136 "cf-parse.y"
    { cmd_show_memory(); ;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 1139 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); ;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 1142 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); ;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 1146 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 1150 "cf-parse.y"
    { if_show(); ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 1153 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 1156 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 1159 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 1165 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 1171 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 1178 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 1183 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 1188 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 1193 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 1197 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 1201 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 1211 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 1219 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 1223 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1230 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1231 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1235 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1239 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1241 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1243 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1245 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1247 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1249 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1251 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1253 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1259 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1260 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1266 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1273 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); ;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1275 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); ;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1277 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1279 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); ;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1281 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1283 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1287 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1291 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); ;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1294 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); ;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1297 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1298 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1299 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1303 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; ;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1304 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; ;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1305 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; ;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1313 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1314 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1323 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1327 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1328 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1329 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1330 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1331 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1332 "cf-parse.y"
    { (yyval.i) = T_QUAD; ;}
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1333 "cf-parse.y"
    { (yyval.i) = T_EC; ;}
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1334 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1335 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1336 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1337 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1338 "cf-parse.y"
    { (yyval.i) = T_ECLIST; ;}
    break;

  case 216:

/* Line 1464 of yacc.c  */
#line 1339 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1360 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1371 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1372 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1379 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1380 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 222:

/* Line 1464 of yacc.c  */
#line 1387 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1396 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1404 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1428 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1429 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1433 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1446 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1449 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1462 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 1463 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; ;}
    break;

  case 233:

/* Line 1464 of yacc.c  */
#line 1466 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); ;}
    break;

  case 234:

/* Line 1464 of yacc.c  */
#line 1467 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); ;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 1471 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 1474 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 1483 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 1496 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 1497 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 1498 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 1499 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); ;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 1503 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 1504 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 1505 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 1506 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 246:

/* Line 1464 of yacc.c  */
#line 1507 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); ;}
    break;

  case 247:

/* Line 1464 of yacc.c  */
#line 1511 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); ;}
    break;

  case 248:

/* Line 1464 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); ;}
    break;

  case 249:

/* Line 1464 of yacc.c  */
#line 1515 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); ;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 1516 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; ;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 1520 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   ;}
    break;

  case 252:

/* Line 1464 of yacc.c  */
#line 1523 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(8) - (11)].i), (yyvsp[(10) - (11)].i)); 
   ;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 1532 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); ;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 1535 "cf-parse.y"
    { (yyval.i) = EC_RT; ;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 1536 "cf-parse.y"
    { (yyval.i) = EC_RO; ;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 1537 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); ;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 1538 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; ;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 1542 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); ;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 1543 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); ;}
    break;

  case 260:

/* Line 1464 of yacc.c  */
#line 1544 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); ;}
    break;

  case 263:

/* Line 1464 of yacc.c  */
#line 1550 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); ;}
    break;

  case 264:

/* Line 1464 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); ;}
    break;

  case 267:

/* Line 1464 of yacc.c  */
#line 1557 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); ;}
    break;

  case 268:

/* Line 1464 of yacc.c  */
#line 1558 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); ;}
    break;

  case 270:

/* Line 1464 of yacc.c  */
#line 1563 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); ;}
    break;

  case 272:

/* Line 1464 of yacc.c  */
#line 1568 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); ;}
    break;

  case 273:

/* Line 1464 of yacc.c  */
#line 1572 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 274:

/* Line 1464 of yacc.c  */
#line 1579 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 275:

/* Line 1464 of yacc.c  */
#line 1580 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 276:

/* Line 1464 of yacc.c  */
#line 1581 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 277:

/* Line 1464 of yacc.c  */
#line 1582 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 278:

/* Line 1464 of yacc.c  */
#line 1589 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 279:

/* Line 1464 of yacc.c  */
#line 1590 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 280:

/* Line 1464 of yacc.c  */
#line 1593 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 281:

/* Line 1464 of yacc.c  */
#line 1594 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   ;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 1601 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 ;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 1613 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 284:

/* Line 1464 of yacc.c  */
#line 1614 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 1618 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 1619 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 1623 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 1624 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 1625 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 1626 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 1627 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 1631 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 1632 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 1633 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 1637 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 1638 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 1639 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 1640 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 1641 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 1642 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 1643 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); ;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 1644 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 1645 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 1646 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 1647 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 1651 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); ;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 1652 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); ;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 1666 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 1689 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_EC:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
       case SYM_VARIABLE | T_ECLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 1725 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 1727 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 1728 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 1729 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 1730 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 1731 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 1732 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 1733 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 1737 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 1738 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 1739 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 1740 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 1741 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 1742 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 1743 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 1744 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 1745 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 1746 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 1747 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 1748 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 1749 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 1750 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 1751 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 1754 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 1755 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 1756 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 1758 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 1760 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 1762 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 1764 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 1765 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 1766 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 1767 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 1768 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 1778 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 1779 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 1780 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; ;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 1781 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 1782 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 1783 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 1784 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; ;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 1789 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 1812 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 355:

/* Line 1464 of yacc.c  */
#line 1813 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 356:

/* Line 1464 of yacc.c  */
#line 1814 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 357:

/* Line 1464 of yacc.c  */
#line 1815 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 358:

/* Line 1464 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 359:

/* Line 1464 of yacc.c  */
#line 1817 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 360:

/* Line 1464 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 361:

/* Line 1464 of yacc.c  */
#line 1824 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 362:

/* Line 1464 of yacc.c  */
#line 1825 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 363:

/* Line 1464 of yacc.c  */
#line 1826 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 364:

/* Line 1464 of yacc.c  */
#line 1835 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 365:

/* Line 1464 of yacc.c  */
#line 1842 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 366:

/* Line 1464 of yacc.c  */
#line 1851 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 367:

/* Line 1464 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 368:

/* Line 1464 of yacc.c  */
#line 1856 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 369:

/* Line 1464 of yacc.c  */
#line 1862 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 370:

/* Line 1464 of yacc.c  */
#line 1872 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 371:

/* Line 1464 of yacc.c  */
#line 1881 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 372:

/* Line 1464 of yacc.c  */
#line 1887 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 373:

/* Line 1464 of yacc.c  */
#line 1892 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 374:

/* Line 1464 of yacc.c  */
#line 1899 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 375:

/* Line 1464 of yacc.c  */
#line 1904 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 376:

/* Line 1464 of yacc.c  */
#line 1910 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 377:

/* Line 1464 of yacc.c  */
#line 1911 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 378:

/* Line 1464 of yacc.c  */
#line 1912 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 379:

/* Line 1464 of yacc.c  */
#line 1920 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); ;}
    break;

  case 380:

/* Line 1464 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 381:

/* Line 1464 of yacc.c  */
#line 1922 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 382:

/* Line 1464 of yacc.c  */
#line 1923 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 383:

/* Line 1464 of yacc.c  */
#line 1924 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 384:

/* Line 1464 of yacc.c  */
#line 1930 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 ;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 1954 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 1955 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); ;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 1956 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 1962 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); ;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 1963 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 392:

/* Line 1464 of yacc.c  */
#line 1964 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 1965 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 394:

/* Line 1464 of yacc.c  */
#line 1966 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 1967 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 396:

/* Line 1464 of yacc.c  */
#line 1968 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 397:

/* Line 1464 of yacc.c  */
#line 1969 "cf-parse.y"
    { BGP_CFG->multihop = 64; ;}
    break;

  case 398:

/* Line 1464 of yacc.c  */
#line 1970 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); ;}
    break;

  case 399:

/* Line 1464 of yacc.c  */
#line 1971 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 400:

/* Line 1464 of yacc.c  */
#line 1972 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 401:

/* Line 1464 of yacc.c  */
#line 1973 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 402:

/* Line 1464 of yacc.c  */
#line 1974 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 1975 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; ;}
    break;

  case 404:

/* Line 1464 of yacc.c  */
#line 1976 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; ;}
    break;

  case 405:

/* Line 1464 of yacc.c  */
#line 1977 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 406:

/* Line 1464 of yacc.c  */
#line 1978 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 407:

/* Line 1464 of yacc.c  */
#line 1979 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); ;}
    break;

  case 408:

/* Line 1464 of yacc.c  */
#line 1980 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 409:

/* Line 1464 of yacc.c  */
#line 1981 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 410:

/* Line 1464 of yacc.c  */
#line 1982 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 411:

/* Line 1464 of yacc.c  */
#line 1983 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 412:

/* Line 1464 of yacc.c  */
#line 1984 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 413:

/* Line 1464 of yacc.c  */
#line 1985 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 414:

/* Line 1464 of yacc.c  */
#line 1986 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 415:

/* Line 1464 of yacc.c  */
#line 1987 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 416:

/* Line 1464 of yacc.c  */
#line 1988 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 417:

/* Line 1464 of yacc.c  */
#line 1989 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 418:

/* Line 1464 of yacc.c  */
#line 1990 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 419:

/* Line 1464 of yacc.c  */
#line 1991 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 420:

/* Line 1464 of yacc.c  */
#line 1992 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 421:

/* Line 1464 of yacc.c  */
#line 1993 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 1994 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 1995 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); ;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 1996 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); ;}
    break;

  case 425:

/* Line 1464 of yacc.c  */
#line 1997 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); ;}
    break;

  case 426:

/* Line 1464 of yacc.c  */
#line 2008 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 430:

/* Line 1464 of yacc.c  */
#line 2025 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 431:

/* Line 1464 of yacc.c  */
#line 2026 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; ;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 2027 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 2028 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 2032 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 2047 "cf-parse.y"
    { ospf_area_finish(); ;}
    break;

  case 439:

/* Line 1464 of yacc.c  */
#line 2056 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ ;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 2057 "cf-parse.y"
    { this_area->type = OPT_N; ;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 2058 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 2059 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); ;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 2060 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 2061 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 2062 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); ;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 2063 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); ;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 2064 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); ;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 2065 "cf-parse.y"
    { this_nets = &this_area->net_list; ;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 2066 "cf-parse.y"
    { this_nets = &this_area->enet_list; ;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 2078 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 460:

/* Line 1464 of yacc.c  */
#line 2092 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 461:

/* Line 1464 of yacc.c  */
#line 2093 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 462:

/* Line 1464 of yacc.c  */
#line 2094 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 2098 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 468:

/* Line 1464 of yacc.c  */
#line 2108 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 469:

/* Line 1464 of yacc.c  */
#line 2109 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 470:

/* Line 1464 of yacc.c  */
#line 2110 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 471:

/* Line 1464 of yacc.c  */
#line 2111 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 472:

/* Line 1464 of yacc.c  */
#line 2112 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 473:

/* Line 1464 of yacc.c  */
#line 2113 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 474:

/* Line 1464 of yacc.c  */
#line 2114 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 475:

/* Line 1464 of yacc.c  */
#line 2115 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 476:

/* Line 1464 of yacc.c  */
#line 2116 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 478:

/* Line 1464 of yacc.c  */
#line 2121 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 479:

/* Line 1464 of yacc.c  */
#line 2142 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 2143 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 481:

/* Line 1464 of yacc.c  */
#line 2144 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 482:

/* Line 1464 of yacc.c  */
#line 2145 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 483:

/* Line 1464 of yacc.c  */
#line 2146 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 484:

/* Line 1464 of yacc.c  */
#line 2147 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 485:

/* Line 1464 of yacc.c  */
#line 2148 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 486:

/* Line 1464 of yacc.c  */
#line 2149 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 487:

/* Line 1464 of yacc.c  */
#line 2150 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 488:

/* Line 1464 of yacc.c  */
#line 2151 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 489:

/* Line 1464 of yacc.c  */
#line 2152 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 490:

/* Line 1464 of yacc.c  */
#line 2153 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 491:

/* Line 1464 of yacc.c  */
#line 2154 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 492:

/* Line 1464 of yacc.c  */
#line 2155 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 493:

/* Line 1464 of yacc.c  */
#line 2156 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; ;}
    break;

  case 494:

/* Line 1464 of yacc.c  */
#line 2157 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 495:

/* Line 1464 of yacc.c  */
#line 2158 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 496:

/* Line 1464 of yacc.c  */
#line 2159 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 497:

/* Line 1464 of yacc.c  */
#line 2160 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 498:

/* Line 1464 of yacc.c  */
#line 2161 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); ;}
    break;

  case 499:

/* Line 1464 of yacc.c  */
#line 2162 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); ;}
    break;

  case 501:

/* Line 1464 of yacc.c  */
#line 2164 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 502:

/* Line 1464 of yacc.c  */
#line 2165 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 503:

/* Line 1464 of yacc.c  */
#line 2166 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 504:

/* Line 1464 of yacc.c  */
#line 2167 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 505:

/* Line 1464 of yacc.c  */
#line 2168 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 506:

/* Line 1464 of yacc.c  */
#line 2169 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); ;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 2181 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 ;}
    break;

  case 513:

/* Line 1464 of yacc.c  */
#line 2191 "cf-parse.y"
    { this_pref->hidden = 1; ;}
    break;

  case 514:

/* Line 1464 of yacc.c  */
#line 2192 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); ;}
    break;

  case 519:

/* Line 1464 of yacc.c  */
#line 2205 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 520:

/* Line 1464 of yacc.c  */
#line 2214 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 521:

/* Line 1464 of yacc.c  */
#line 2224 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 526:

/* Line 1464 of yacc.c  */
#line 2255 "cf-parse.y"
    { ospf_iface_finish(); ;}
    break;

  case 528:

/* Line 1464 of yacc.c  */
#line 2260 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 529:

/* Line 1464 of yacc.c  */
#line 2265 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 530:

/* Line 1464 of yacc.c  */
#line 2268 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 531:

/* Line 1464 of yacc.c  */
#line 2271 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 532:

/* Line 1464 of yacc.c  */
#line 2276 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); ;}
    break;

  case 533:

/* Line 1464 of yacc.c  */
#line 2279 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); ;}
    break;

  case 534:

/* Line 1464 of yacc.c  */
#line 2284 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); ;}
    break;

  case 535:

/* Line 1464 of yacc.c  */
#line 2287 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); ;}
    break;

  case 536:

/* Line 1464 of yacc.c  */
#line 2290 "cf-parse.y"
    { ospf_sh_lsadb(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf)); ;}
    break;

  case 537:

/* Line 1464 of yacc.c  */
#line 2295 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  ;}
    break;

  case 540:

/* Line 1464 of yacc.c  */
#line 2305 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 541:

/* Line 1464 of yacc.c  */
#line 2310 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 542:

/* Line 1464 of yacc.c  */
#line 2311 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 543:

/* Line 1464 of yacc.c  */
#line 2317 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 546:

/* Line 1464 of yacc.c  */
#line 2326 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 547:

/* Line 1464 of yacc.c  */
#line 2327 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 548:

/* Line 1464 of yacc.c  */
#line 2328 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 549:

/* Line 1464 of yacc.c  */
#line 2329 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 550:

/* Line 1464 of yacc.c  */
#line 2330 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 551:

/* Line 1464 of yacc.c  */
#line 2331 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 553:

/* Line 1464 of yacc.c  */
#line 2333 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 554:

/* Line 1464 of yacc.c  */
#line 2334 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 555:

/* Line 1464 of yacc.c  */
#line 2335 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 557:

/* Line 1464 of yacc.c  */
#line 2340 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 558:

/* Line 1464 of yacc.c  */
#line 2341 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 559:

/* Line 1464 of yacc.c  */
#line 2342 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 560:

/* Line 1464 of yacc.c  */
#line 2347 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 561:

/* Line 1464 of yacc.c  */
#line 2348 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 562:

/* Line 1464 of yacc.c  */
#line 2349 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 563:

/* Line 1464 of yacc.c  */
#line 2350 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 564:

/* Line 1464 of yacc.c  */
#line 2351 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 566:

/* Line 1464 of yacc.c  */
#line 2355 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 567:

/* Line 1464 of yacc.c  */
#line 2356 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 572:

/* Line 1464 of yacc.c  */
#line 2370 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 574:

/* Line 1464 of yacc.c  */
#line 2386 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 577:

/* Line 1464 of yacc.c  */
#line 2395 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); ;}
    break;

  case 578:

/* Line 1464 of yacc.c  */
#line 2396 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); ;}
    break;

  case 580:

/* Line 1464 of yacc.c  */
#line 2400 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 581:

/* Line 1464 of yacc.c  */
#line 2409 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (2)].a);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   ;}
    break;

  case 582:

/* Line 1464 of yacc.c  */
#line 2416 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   ;}
    break;

  case 583:

/* Line 1464 of yacc.c  */
#line 2423 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; ;}
    break;

  case 584:

/* Line 1464 of yacc.c  */
#line 2424 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; ;}
    break;

  case 585:

/* Line 1464 of yacc.c  */
#line 2428 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 586:

/* Line 1464 of yacc.c  */
#line 2432 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   ;}
    break;

  case 587:

/* Line 1464 of yacc.c  */
#line 2438 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   ;}
    break;

  case 588:

/* Line 1464 of yacc.c  */
#line 2441 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 589:

/* Line 1464 of yacc.c  */
#line 2445 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 590:

/* Line 1464 of yacc.c  */
#line 2446 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 591:

/* Line 1464 of yacc.c  */
#line 2447 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 592:

/* Line 1464 of yacc.c  */
#line 2451 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 646:

/* Line 1464 of yacc.c  */
#line 2459 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 647:

/* Line 1464 of yacc.c  */
#line 2459 "cf-parse.y"
    { ospf_proto_finish(); ;}
    break;

  case 649:

/* Line 1464 of yacc.c  */
#line 2459 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 658:

/* Line 1464 of yacc.c  */
#line 2462 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); ;}
    break;

  case 659:

/* Line 1464 of yacc.c  */
#line 2462 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); ;}
    break;

  case 660:

/* Line 1464 of yacc.c  */
#line 2463 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); ;}
    break;

  case 661:

/* Line 1464 of yacc.c  */
#line 2463 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 662:

/* Line 1464 of yacc.c  */
#line 2464 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 663:

/* Line 1464 of yacc.c  */
#line 2465 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 664:

/* Line 1464 of yacc.c  */
#line 2466 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 665:

/* Line 1464 of yacc.c  */
#line 2467 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 666:

/* Line 1464 of yacc.c  */
#line 2468 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 667:

/* Line 1464 of yacc.c  */
#line 2469 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 668:

/* Line 1464 of yacc.c  */
#line 2470 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 669:

/* Line 1464 of yacc.c  */
#line 2471 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 670:

/* Line 1464 of yacc.c  */
#line 2472 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); ;}
    break;

  case 671:

/* Line 1464 of yacc.c  */
#line 2473 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); ;}
    break;

  case 672:

/* Line 1464 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); ;}
    break;

  case 673:

/* Line 1464 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 674:

/* Line 1464 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 675:

/* Line 1464 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 676:

/* Line 1464 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); ;}
    break;

  case 677:

/* Line 1464 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 678:

/* Line 1464 of yacc.c  */
#line 2474 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1464 of yacc.c  */
#line 7875 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 2476 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


